
#ifndef CERA_GROUP_H
#define CERA_GROUP_H

#define CERA_GROUP_MAX			4
#define CERA_GROUP_MAX_OBJS		10
#define CERA_FLINCH_CNT			5

enum
{
	CERA_GROUP_WAIT_CHASE,
	CERA_GROUP_CHASE_ACTIVE
};

enum
{
	LOOK_CAM_SPLINE,
	LOOK_CLOSEST,
	LOOK_RETURNING,
	LOOK_DONE
};

typedef struct Cera_Group
{
	int id;
	int	num_objs;
	uns32 oids[CERA_GROUP_MAX_OBJS];
	int in_use;
	SM_Cera_Params* cera_params[CERA_GROUP_MAX_OBJS];
	ObjFunc* obj_func;

	// state control
	int state;

	// chase point
	float path_width;
	float path_full_dist;
	float path_min_width;

	// attacking
	float attack_dist;
	float attack_slow_pct;
	float attack_slow_sec;
	float attack_recover_sec;

	// hit
	float hit_slow_pct;
	float hit_recover_sec;
	float hit_min_speed_pct;
	int flinch_list[CERA_FLINCH_CNT];	// flags for if we have played a flinch already
	int last_flinch;


	// death
	float death_after_frame;

	// speed control
	float speed_pct;
	float speed_pct_smooth;
	float turn_smooth;

	// camera control
	int look_state;
	crd look_rot_last_quat[4];
	float look_smooth;
	float look_return_frame;
	float look_return_sec;
	crd look_return_qstart[4];
	crd look_return_qend[4];
	uns32 look_return_stick;

	// blending
	float blend_attack;
	float blend_flinch;
	float blend_interrupt;
	float blend_death;

	// camera info
	ObjCam* cam_obj;
	ObjVel* cam_ov;
	ObjKeyAnim* cam_okan;

	// spline/chase speed transition
	float trans_time_sec;

} Cera_Group;


// cera group function prototypes

Cera_Group* CeraGroupGetByID( int id );
int CeraGroupRegister( char* groupName );

#endif


