#ifndef CIRCLES_TUTORIAL_H_
#define CIRCLES_TUTORIAL_H_


#include "game.h"


void CirclesTutorial_Start();


typedef enum DinoPanelDino
{
	DINO_PANEL_TRICERA,
	DINO_PANEL_TREX,
	DINO_PANEL_BRACH,
	DINO_PANEL_SPINO,
	DINO_PANEL_PTERA,

	NUM_DINO_PANEL_DINOS

} DinoPanelDino;


typedef struct DinoPanelData
{
	DinoPanelDino dino;

	// background panel
	ObjDispRes* bgODR;
	ObjDispRes* textBgODR;
	// big dino icon
	ObjDispRes* dinoODR;

	// name text
	ObjDispRes* dinoNameODR;
	// instructions text
	ObjDispRes* instrODR;

} DinoPanelData;


void DinoPanel_Create(ObjGroup* ogrp, DinoPanelData* panel, DinoPanelDino dino, int circles);
void DinoPanel_SetAlpha(DinoPanelData* panel, float a);
void DinoPanel_BGTransition(DinoPanelData* panel, float t);
void DinoPanel_TextTransition(DinoPanelData* panel, float t);
void DinoPanel_DinoTransition(DinoPanelData* panel, float t);


#endif