// credit_msg.h
// Play Mechanix - Video Game System
// Copyright (c) 2010 Play Mechanix Inc. All Rights Reserved
//

#ifndef CREDIT_MSG_H
#define CREDIT_MSG_H

#include "game.h"


//////////////////////////////////////////////////////////////////////////
// CreditMsg
//////////////////////////////////////////////////////////////////////////

// display messages related to machine credits

// credit message text phrases
enum
{
	CREDIT_MSG_BALANCE=0,
	CREDIT_MSG_INSERT_COINS,
	CREDIT_MSG_CREDIT_TO_START,
	CREDIT_MSG_START_JOIN,
	CREDIT_MSG_START_BEGIN,
	CREDIT_MSG_FREEPLAY,
	CREDIT_MSG_COUNT
};

// credit message public interface
void CreditMsg_Reset();
void CreditMsg_Create();
void CreditMsg_Kill();
void CreditMsg_SetPos( crd* pos );
void CreditMsg_SetPosToDflt();
void CreditMsg_SetActive( int id, int active );
void CreditMsg_SetAttract( int active );
void CreditMsg_GotoNextMessage();
void CreditMsg_Hide();
void CreditMsg_Show();
int CreditMsg_IsShown();
int CreditMsg_IsFading();
void CreditMsg_FadeIn( uns32 ms );
void CreditMsg_FadeOut( uns32 ms );
int CreditMsg_GetCoinDropped();

// credit message proc callbacks
int CreditMsg_ProcStart( void *params );
void CreditMsg_ProcRun();
void CreditMsg_ProcKill( void *params );


#endif // CREDIT_MSG_H

