#ifndef DINO_TRIGGER_GROUP_H_
#define DINO_TRIGGER_GROUP_H_


#include "game.h"


// DinoGroup data for grouping dinos that are triggered together.
typedef struct DinoTrigGrpData
{
	ObjGroup* ogrp;

	// time since this group's start trigger was hit. < 0 if not triggered yet.
	float timeSinceTrigger;
	float timeSinceShowTrigger;
	// camera that was active when trigger was hit. We use this to measure time in case the camera pauses
	uns32 startCamOID;

	// save game time when the trigger was hit
	uns32 triggerHitTime;

	// time between launching each dino
	float launchDelay;
	// time after trigger before displaying dino
	float showDelay;
	// time after trigger before launching first dino
	float groupDelay;

	int useCamSpeed;

	// number of dinos ready to launch
	uns32 numReady;
	// total number launched since group trigger
	uns32 numLaunched;

	int show;

	char triggerName[32];
	char showTriggerName[32];

} DinoTrigGrpData;


void DinoTrigGrp_Add(SM_Enemy_Params* params);
void DinoTrigGrp_Remove(SM_Enemy_Params* params);


#endif