// full-auto. machine gun
#ifndef GAME_GUN_MG_H
#define GAME_GUN_MG_H


#include "game.h"



typedef struct GunMuzzleData
{
	ObjDispRes* model[NUM_GUN_TYPES][MAX_GUN_PARTS];
	ObjVel* modelOv[NUM_GUN_TYPES][MAX_GUN_PARTS];
	ObjTransform* kickbackTransform[NUM_GUN_TYPES][MAX_GUN_PARTS];
	ObjDispRes* laser;
	ObjVel* ovLaser;
	ObjTransform* kickbackLaser;
	int PlayerNum;
	crd ScreenPos[3];
	int enableWeaponModels;

	float FreezeGunRot;
	float FreezeGunVel;

	float MinigunGunRot;
	float MinigunGunVel;

	float ElectroGunRot;
}GunMuzzleData;


void GunMGSetConfig();

void GunMGInit();
void GunMGCreate();
void GunMGDestroy();

int GunMGGetClipCapacity();

int GunMGDisable(int pnum);
int GunMGUpdate(int pnum);
int GunMGShoot( int input, uns32 state, io_input_analog *ai, io_input_digital *trigger, void *data );
void GunMGLaunchBullet(GunMuzzleData* gmd, float gunScale, int randomize);
void GunMGKickBack(GunMuzzleData* gmd);
int GunMGReload( int input, uns32 state, io_input_analog *ai, io_input_digital *trigger, void *data );

// gun ammo
void GunReloadPlayer( int player_num );
int GunGetClipCount( int player_num );
void GunDecClipCount( int player_num );
void GunSetClipCount( int player_num, int ammo );
int GunGetMaxClipCount();

void GunPlayEmptyClipSfx( int player_num );
int GunMGColaDeath( void* );

// sfx
void GunMG_SFX_Fire( int pnum );
void GunMG_SFX_Update( int pnum );
void GunMG_SFX_Stop( int pnum );



#endif