#ifndef GAME_QR_H_
#define GAME_QR_H_


#include "game.h"


#define GAME_QR_NUM_PLAYERS	2


typedef struct GameQRScoreData
{
	uns8 isSet;
	uns8 pnum;
	uns32 lvlScore[GAME_NUM_LEVELS];
	float acc;
	uns16 streak;

} GameQRScoreData;


void GameQR_Startup();
void GameQR_Shutdown();

// clear the current QR code instance and make a new one
void GameQR_Reinit();
int GameQR_HasInst();
QRCodeData* GameQR_GetInst();

void GameQR_SetName( int pnum, char* name );

void GameQR_SetScore( GameQRScoreData* sd );
void GameQR_GetScore( GameQRScoreData* sd );
int GameQR_IsScoreSet( uns8 pnum );

void GameQR_UpdateAud();
void GameQR_UpdateAdj();

void GameQR_UpdateCrashDump();
void GameQR_PrintCrashDumpFromQR( QREntry* in );


#define GAME_QR_DISP_INFINITE_DURATION	UINT_MAX

typedef enum GameQRDispType
{
	GAME_QR_DISP_TYPE_ATTRACT,
	GAME_QR_DISP_TYPE_CONTINUE,

} GameQRDispType;

typedef enum GameQRDispState
{
	GAME_QR_DISP_STATE_FADE_IN,
	GAME_QR_DISP_STATE_WAIT,
	GAME_QR_DISP_STATE_FADE_OUT,
	GAME_QR_DISP_STATE_DONE,

} GameQRDispState;

extern float gQRDispDfltPanelPos[V3_SIZE];

uns32 GameQRDisp_Create( uns8 pnum, QRCodeData* qrd, uns32 duration, GameQRDispType type, GameQRDispState startState );
void GameQRDisp_Destroy( uns32 oid );

void GameQRDisp_SetPanelPos( uns32 oid, float* pos );


#endif