// game_sys.h
// Play Mechanix - Video Game System
// Copyright (c) 2010 Play Mechanix Inc. All Rights Reserved
//

#ifndef GAME_SYS_H
#define GAME_SYS_H

#include "game.h"

#define FILEACCESS_TYPE_ATTRACT_PAGES		"ATTRACT_PAGES"
#define FILEACCESS_TYPE_ATTRACT_ORDER		"ATTRACT_ORDER"
#define	FILEACCESS_TYPE_AUD_DEFAULT_GAME	"AUD_DEFAULT_GAME"

extern HashTable gGameConf;  // all sorts of general game config items...


int GameSetup(); // look here for setup of g5 systems (turn on/off render features, sound params, etc)
void ReadSerialNumber();
int GameInit(); // look for here for init of game specific systems
int GameLoadPerm();
int GameLoadConf(); // look for here for loading game configs
void GameSetVariableInputMaps();
int GameInputMaps(); // look for here for input mapping
int GameSetupTextCallbacks(); // look here for text populate callbacks
int GameSetupCPMGUICallbacks(); // look here for cpmgui callbacks
ObjDispRes* Game_MakeText( Res* res, char* str_id );

int GameSysStart( int argc0,char *argv0[] ); // this guy calls all setup/init funcs, the one you wanna call
int GameSysFinal();
int GameSysLoop();

void GameDiagStart(char* menu);

#ifndef NO_TOOL
// what happens when you hit the reload conf button in the tool?
int GameReLoadConf(void);
void GameResetKeyPressed();
#endif

#endif // GAME_SYS_H
