#ifndef LOCATION_DIAG_H_
#define LOCATION_DIAG_H_


// for setting location/venue strings (used in QR codes)


#include "game.h"




#define ENTER_STRING_CELL_WIDTH	95.0f
#define ENTER_STRING_CELL_HEIGHT	90.0f

typedef enum EnterStringOpt
{
	ENTER_STRING_OPT_SPACE,
	ENTER_STRING_OPT_COMMA,
	ENTER_STRING_OPT_ERASE,
	ENTER_STRING_OPT_CLEAR_ALL,

	ENTER_STRING_OPT_COUNT

} EnterStringOpt;

#define ENTER_STRING_NUM_LETTERS	26
#define ENTER_STRING_NUM_DIGITS	10

typedef struct EnterStringData
{
	char* str;
	uns32 strMaxSize;

	uns32 grp;

	// ODR oids
	uns32 letters[ENTER_STRING_NUM_LETTERS];
	uns32 digits[ENTER_STRING_NUM_DIGITS];
	uns32 options[ENTER_STRING_OPT_COUNT];

	int cancel;

} EnterStringData;

extern EnterStringData gEnterStringData;
ObjDispRes* EnterStringMenuCreateButton( char* strId, int xIdx, int yIdx, ObjGroup* ogrp );
void CreateEnterStringMenu( char* str, uns32 strMaxSize, int numOnly );
void EnterStringUpdateLetter( int idx );
void EnterStringUpdateDigit( int idx );
void EnterStringUpdateOpt( int idx );
int EnterStringUpdateButton( uns32 oid );
int EnterStringCheckCursorHover( uns32 oid, uns32 gnum );
void EnterStringAddChar( char c );
void EnterStringMenuOnFocusCB( menu_t *menu );
void EnterStringMenuLeaveFocusCB( menu_t *menu );
void EnterStringMenuUpdateCB( menu_t *menu );
int EnterNameConfirmBttnCB( ObjCPMGuiRes *ocpmg );
int EnterNameCancelBttnCB( ObjCPMGuiRes *ocpmg );


EXTERN_C menu_type_t MenuType_DiagEnterVenue;
EXTERN_C menu_t DiagEnterVenue;

EXTERN_C menu_type_t MenuType_DiagEnterLocation;
EXTERN_C menu_t DiagEnterLocation;


EXTERN_C void textCallback_DiagEnterString_Val( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );
EXTERN_C void textCallback_DiagEnterVenue_VALUE( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );
EXTERN_C void textCallback_DiagEnterLocation_VALUE( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );


#endif