#ifndef PTRDON_GRP_H_
#define PTRDON_GRP_H_


#include "game.h"
#include "ptrdon.h"
#include "dino_group.h"


typedef struct PtrdonGrpData
{
	int numToSpawn;

	int attackFromPath;
	// time (ms) after path starts to start sending pteras to attack the
	// player.
	float pathAtkStartDelay;
	// time (ms) between each ptera attacking player.
	float pathAtkPeriod;
	// total ptrdons from this group currently seeking a path
	uns32 numPathPtrdons;
	// time that first path ptrdon from this group started seeking
	uns32 pathLaunchTime;
	// number of pteras currently on a path that should leave the path to attack
	uns32 numPathAtkReady;
	// number of pteras already sent from the path to attack
	uns32 numPathAtks;

	ObjFunc* destructor;

} PtrdonGrpData;


void PtrdonGrp_Create(SM_PtrdonGrp_Params* params);
void PtrdonGrp_Update(SM_PtrdonGrp_Params* params);
void PtrdonGrp_Destroy(SM_PtrdonGrp_Params* params);

void PtrdonGrp_AddPathPtrdon(SM_PtrdonGrp_Params* params, SM_Ptrdon_Params* pParams);
void PtrdonGrp_RemovePathPtrdon(SM_PtrdonGrp_Params* params, SM_Ptrdon_Params* pParams);


#endif