
#ifndef TRICERA_STATEMACHINE_H
#define TRICERA_STATEMACHINE_H



enum TriceraStateMachineStates
{
	SM_TRICERASTATES_SPLINE_DRIVE = SM_ENEMYSTATES_MAX,
	SM_TRICERASTATES_WATCH,
	SM_TRICERASTATES_HEAD_DOWN,
	SM_TRICERASTATES_SHOT,

	SM_TRICERASTATES_MAX,
	NUM_SM_TRICERASTATES = (SM_TRICERASTATES_MAX - SM_ENEMYSTATES_MAX + NUM_SM_ENEMYSTATES),
};


typedef struct TriceraDriveParams
{
	ResDataKan* rdk;
	ResDataKanKey* keys;
	float time;
	float desiredState;
	float currentState;

	float lastGndOffset;

	SM_TravelFunc_Params travelParams;
} TriceraDriveParams;



extern PSM_State gTriceraStateMachineStates[NUM_SM_TRICERASTATES];
extern PSM_StateMachine gTriceraStateMachine;


int SM_Tricera_SplineDrive( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_Tricera_Watch( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_Tricera_SetPitch( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );
int SM_Tricera_Shot( PSM_ExeContext *context, void *statemachine_params, void *state_params, uns32 state_updates, float state_elapsed_time, float *elapsed_time  );


int TriceraDrive_Init(ObjDispRes* prime,  ObjTrackAnim* otan, ObjVel* objVel, ObjVelController* velCtrl, char* splineName, int bSnapToStart);
int TriceraDrive_Update(ObjVel* objVel, float deltaTime);
int TriceraDrive_Free(ObjVelController* velCtrl);




#endif


