#ifndef WASP_GLOBAL_H_
#define WASP_GLOBAL_H_


#include "game.h"
#include "wasp.h"


#define WASP_SCREEN_SLOTS_W		3
#define WASP_SCREEN_SLOTS_H		2
#define WASP_NUM_SCREEN_SLOTS	WASP_SCREEN_SLOTS_W * WASP_SCREEN_SLOTS_H


// data shared for all active wasps
typedef struct WaspGlobalData
{
	// is initialized
	int isInitd;

	float health;
	float attackerHealth;

	// total wasps currently reserving a screen slot
	uns32 numScreenWasps;
	uns32 maxScreenWasps;
	// number of wasps currently in this slot
	int screenSlot[WASP_SCREEN_SLOTS_W][WASP_SCREEN_SLOTS_H];

	uns32 nextSlotIdx;

	float focusDist;

	ObjFunc* updateFunc;

	int drawDebug;
	
	// swarm sound
	uns32 numSwarmSounds;
	int soundID;
	crd soundPos[3];
	float soundCnt;

} WaspGlobalData;


extern WaspGlobalData gWaspGlobalData;


// create a new wasp object with an optional swarm (pass null for no swarm)
SM_Wasp_Params* CreateWasp(Res* res, SM_WaspSwarm_Params* sParams);


void WaspGlobal_StartUp();
void WaspGlobal_ShutDown();
void WaspGlobal_Reset();

void WaspGlobal_AddScreenWasp(SM_Wasp_Params* wParams);
void WaspGlobal_RemoveScreenWasp(SM_Wasp_Params* wParams);
void WaspGlobal_UpdateScreenWasp(SM_Wasp_Params* wParams);

void WaspGlobal_StartSwarmSound();
void WaspGlobal_StopSwarmSound();

void WaspGlobal_DrawDebug();


// pass back camera-space position
void WaspGlobal_GetScreenWaspCamPos
	(SM_Wasp_Params* wParams, ObjCam* cam, crd* vOut);


#endif