#ifndef ADJ_H
#define ADJ_H

// AdjDef, AdjValStore and AdjGroupDef struct defined in core_rtdt_datatypes

enum {
	ADJ_ERR_NONE = 0,
	ADJ_ERR_BAD_PARAMS    = -1,
	ADJ_ERR_NOT_FOUND     = -2,
	ADJ_ERR_GRP_NOT_FOUND = -3,
	ADJ_ERR_OUT_OF_RANGE  = -4,
	ADJ_ERR_HASH_ERR      = -5,
	ADJ_ERR_FILE_ERR      = -6,

};

#define ADJ_SAVE_COPIES 3


int   Adj_Setup_AddDefsPath( char *path );

int Adj_Init();
int Adj_Final();

int   Adj_AddGroup( AdjGroupDef *def );
int   Adj_AddDefs( char *group, AdjDef *defs, int count);
int	  Adj_AddLookupTable( char *name, char **text_identifiers, int count );

int Adj_Exists(char *group, char *name);

int   Adj_Get(char *group, char *name);
time_t Adj_GetTime(char *group, char *name);
int   Adj_Set(char *group, char *name, int val);
float Adj_GetFloat(char *group, char *name);
int   Adj_SetFloat(char *group, char *name, float val);
int   Adj_Default(char *group, char *name);

int   Adj_GetMin(char *group, char *name);
int   Adj_GetMax(char *group, char *name);
int	  Adj_GetDivisor(char *group, char *name);
int   Adj_GetStepValue(char *group, char *name);
int   Adj_GetDisplayAsCurrency(char *group, char *name);
int   Adj_GetDisplayAsTime(char *group, char *name);
int   Adj_GetDisplayAsDate(char *group, char *name);
int   Adj_GetDisplayAsPercentage(char *group, char *name);
int   Adj_OnlineReconcile(char *group, char *name);
int	  Adj_AdminOnly(char *group, char *name);

int   Adj_LoadDefs();
int   Adj_DefaultAllVals(int set_current_time);
int   Adj_LoadVal( char *group, char *name );
int   Adj_LoadVals();

int   Adj_Save( char *group, char *name );
int   Adj_SaveDirty();
int   Adj_ClearDirty();
int   Adj_SaveAll();

int   Adj_LoadLookupTables();
char  *Adj_GetLookupTable(char *group, char *name);
char  *Adj_LookupTablesGetVal( char *name, int index );

char  *Adj_GetSoundToPlay( char *group, char *name );
char  *Adj_GetRumbleToPlay( char *group, char *name );
int    Adj_GetSoundLoop( char *group, char *name );

int   Adj_Set_VersionMigrateFunc( char *group, char *name, int (*MigrateFunc)(char *group, char *name, AdjValStore *avstore ) );
int   Adj_DefaultVersionMigrateFunc(char *group, char *name, AdjValStore *avstore );

int	  Adj_OverrideStepValue(char *group, char *name, int step_value);

int   Adj_ResetAll( void );
void Adj_SetCountryDefaults( CountryCodes country );
int   Adj_GetGroupList(List *list);
int   Adj_GetAdjListFromGroup(char *group, List *list);

#endif	// ADJ_H
