#ifndef ADJ_DIAG_H
#define ADJ_DIAG_H

// adj_diag.h
// Copyright (c) 2011 Play Mechanix Inc. All Rights Reserved
//
// JAL 29-Mar-2011: Adjustments-related diag functionality

// Adjustment menu priorities
#define DIAG_PRI_ADJUSTMENTS		1


// Proc declarations
#define DIAGADJGAMEVOL_PROC		"AdjGameVolProc"
#define DIAGADJATTRACTVOL_PROC	"AdjAttractVolProc"

typedef struct adjustment_info_t
{
	char adj_group[PM_NAME_SIZE];		// Adjustment group name
	char adj_name[PM_NAME_SIZE];		// Adjustment name
	int tempValue;						// Temporary value used for display while adjusting
	int prevValue;						// Previously saved adjustment value
	int min;							// Minimum value
	int max;							// Maximum value
	int divisor;						// Divisor (for display as float)
	int stepValue;						// Value to increment / decrement adjustment by
	char lookup_table[PM_NAME_SIZE];	// Lookup table name
	char sound_to_play[PM_NAME_SIZE];	// Sound to play while adjustment is made
	char rumble_to_play[PM_NAME_SIZE];	// Rumble to play while adjustment is made
	int sound_loop;
	int displayAsTime;					// 1 = Display adjustment in a time format
	int displayAsDate;					// 1 = Display adjustment in a date format
	int displayAsCurrency;				// 1 = Display adjustment in a currency format
	int displayAsPercentage;			// 1 = Display adjustment in a percentage format
}adjustment_info_t;

typedef void (*CabTypeRefreshCB)( int resetAdj );
extern CabTypeRefreshCB gCabTypeRefreshCB;

typedef void (*LampsEnableRefreshCB)();
extern LampsEnableRefreshCB gLampsEnableRefreshCB;

EXTERN_C int AdjDiagInit();
EXTERN_C int AdjMenuInstallAdjustment( char* group, char* name, char* parent );
EXTERN_C int AdjMenuInstallAllAdjustments();

EXTERN_C menu_type_t MenuType_DiagAdjustment;
EXTERN_C menu_type_t MenuType_DiagAdjustmentOnOff;
EXTERN_C menu_t DiagMenuAdjustments;
EXTERN_C menu_t DiagMenuAdjustmentsGroup;
EXTERN_C menu_t DiagMenuAdjustmentsAdj;
EXTERN_C menu_t DiagMenuSetDateTime;

EXTERN_C CountryCodes AdjLangToCountryCode( int lang );


#endif // ndef ADJ_DIAG_H

// EOF

