// anim.h
// Copyright 2010 Play Mechanix Inc. All Rights Reserved
//

#ifndef ANIM_H
#define ANIM_H

#include "g5.h"

extern HashTable gTravelAnimCollections; // maps name to travel anim collection

typedef struct AnimList
{
	HashTable prev_anim;
	List list;
} AnimList;


int AnimInit();
int AnimFinal();
int AnimReload();


extern HashTable gAniActConf;
int AniActions_Load();
int AniActions_Reload();


int AnimListsInit();
int AnimListsReset();
int AnimListsFinal();
int AnimListsReload();
int LoadAnimListFile( char *file );
int LoadAnimListFileCB( char *file, void *data );
int AnimListsSetRandSeed(unsigned int seed);

Res *AnimListsGetNextAnim( uns32 requestor_oid, char *name );


int TravelAnimsInit();
int TravelAnimsReload();
int LoadTravelAnimCollectionFile( char *name, char *file );

int DieAnimsInit();
int DieAnimsReload();
int LoadDieAnimCollectionFile( char *name, char *file );

int HitAnimsInit();
int HitAnimsReload();
int LoadHitAnimFile( char *name, char *file );
//int FindTravelAnims( TravelAnimCollection *tac, float speed, float inv_tradius, TravelAnim **slow, TravelAnim **fast );

enum {

	// fields for FindTravelAnims results
	FTAR_LP_LS_LT = 0,  // Low Pitch, Low Speed, Low Turn
	FTAR_LP_LS_HT,  // Low Pitch, Low Speed, High Turn
	FTAR_LP_HS_LT,  // Low Pitch, High Speed, Low Turn
	FTAR_LP_HS_HT,  // Low Pitch, High Speed, High Turn
	FTAR_HP_LS_LT,  // High Pitch, Low Speed, Low Turn
	FTAR_HP_LS_HT,  // High Pitch, Low Speed, High Turn
	FTAR_HP_HS_LT,  // High Pitch, High Speed, Low Turn
	FTAR_HP_HS_HT,  // High Pitch, High Speed, High Turn
	NUM_FTAR,

};

enum {

	// fields for FindTravelAnims_SpeedOnly results
	FTAR_SPEED_LS= 0, // High Speed
	FTAR_SPEED_HS,	  // Low Speed
	NUM_FTAR_SPEED,
};

int FindTravelAnims( TravelAnimCollection *tac, float pitch, float speed, float inv_tradius, TravelAnim **results );
char *FindDieAnim( char *animal, char *colbox, char side, float speed, float distance, DieAnim **pdanim );
char *FindHitAnim( char *res, char* col );
//char *FindDieFXGroup( char* animal );
//float FindDieFXVelMul( char* animal );
// int FindDieFXGroup( char* animal, char **fxgroup, float *FXVelMul, int *dieFX_do_rot, int *dieFX_do_scale, int *dieFX_use_objpos, int *keep_alive );

DieAnimCollection *FindDieAnimCollection( char *animal );

int CheckDieAnimNoStop( char* animal );

int DieAnimsCmp( const void *a, const void *b );


#endif

