#ifndef AUD_DIAG_H
#define AUD_DIAG_H

// aud_diag.h
// Copyright  2011 Play Mechanix Inc. All Rights Reserved
//
// JAL 03-Jun-2011: Audits-related diag functionality

// Audit menu priorities
#define DIAG_PRI_AUDITS				2	// Where the main audits menu sits in the main diag menu

// should match number of lines in the diag menu layout definition (diag.csv and diag.xml)
#define VIEWAUD_NUM_LINES_PER_PAGE		18

typedef enum DiagMenuCoreAuditsPriority
{
	DIAG_PRI_AUDITS_COIN = 1,
	DIAG_PRI_AUDITS_SYSTEM,
	DIAG_PRI_AUDITS_GAMEPLAY,
	DIAG_MENU_CORE_AUDITS_PRIORITY_END,
} DiagMenuCoreAuditsPriority;

typedef struct view_aud_info_t {
	int  pageNumber;
	int  pageCount;
} view_aud_info_t;

extern view_aud_info_t gViewAudInfo;


typedef struct AudDiagItem
{
	int type;

	// text to display in the diag menu
	char* name;

} AudDiagItem;



typedef enum CoinAudItemType
{
	COINAUD_TOTAL,
	COINAUD_SPENT,
	COINAUD_UNSPENT,
	COINAUD_COIN0_CLICKS,
	COINAUD_COIN0_MONEY,
	COINAUD_COIN1_CLICKS,
	COINAUD_COIN1_MONEY,
	COINAUD_COIN2_CLICKS,
	COINAUD_COIN2_MONEY,
	COINAUD_COIN3_CLICKS,
	COINAUD_COIN3_MONEY,
	COINAUD_CREDIT_CARD_SWIPES,
	COINAUD_CREDIT_CARD_MONEY,
	COINAUD_SERVICE_PRESSES,
	COINAUD_SERVICE_MONEY,
	COINAUD_COINDROPS,
	COINAUD_CURRENT_CREDITS,
	COINAUD_LIFETIME_COINS,

	NUM_COIN_AUD_ITEM_TYPES

} CoinAudItemType;

EXTERN_C char* gCoinAudStrIds[NUM_COIN_AUD_ITEM_TYPES];


typedef enum SystemAudItemType
{
	SYSAUD_START_DATE,

	SYSAUD_TIMEON,
	SYSAUD_BOOTS,
	SYSAUD_DIAG_ENTRIES,
	SYSAUD_MAINT_REBOOTS,
	SYSAUD_NO_IO_BOARD,
	SYSAUD_IO_DISCONNECTS,
	SYSAUD_IO_RECONNECTS,
	SYSAUD_WATCHDOGS,
	SYSAUD_EXCEPTIONS,
	SYSAUD_TRAPS,

	NUM_SYSTEM_AUD_ITEM_TYPES

} SystemAudItemType;

EXTERN_C char* gSystemAudStrIds[NUM_SYSTEM_AUD_ITEM_TYPES];


EXTERN_C int AudDiagInit(void);

void AudMenuAddScrollbar(menu_t *menu);
void AudCoinExport(FILE* fd);
void AudSysExport(FILE* fd);


EXTERN_C menu_type_t MenuType_DiagAuditCoin;
EXTERN_C menu_type_t MenuType_DiagAuditSystem;
EXTERN_C menu_type_t MenuType_DiagAuditGameplay;
EXTERN_C menu_t DiagMenuAudits;
EXTERN_C menu_t DiagMenuAuditsCoin;
EXTERN_C menu_t DiagMenuAuditsSystem;
EXTERN_C menu_t DiagMenuAuditsGameplay;


#endif // ndef AUD_DIAG_H

// EOF

