#ifndef BOOT_CRC_H_
#define BOOT_CRC_H_


typedef enum BootCRCError
{
	BOOT_CRC_ERROR_NONE,
	BOOT_CRC_ERROR_NULL_PARAM,
	BOOT_CRC_ERROR_FILE_IO,
	BOOT_CRC_ERROR_FILE_LIST_IO,
	BOOT_CRC_ERROR_PARSE,
	BOOT_CRC_ERROR_SIZE_MISMATCH,
	BOOT_CRC_ERROR_CRC_MISMATCH,

} BootCRCError;


// build a list just for testing. it won't have the same files as the list
// made in the final build.
BootCRCError BootCRC_BuildList( char* listFilepath );
// run inside a proc since it takes a long time. don't want watchdog to time out.
BootCRCError BootCRC_CheckList( char* listFilepath, char* curFilepath );


#endif