#ifndef CASHBOX_H
#define CASHBOX_H

// cashbox.h
// Copyright (c) 2010 Play Mechanix Inc. All Rights Reserved
//

// CashBox audits are defined in core rtdt datatypes file

// AUD_CASHBOX is declared in aud.h

typedef struct coinType_t
{
	char	AdjName[ADJ_NAME_SIZE];
	char	coinType_value;
} coinType_t;

enum
{
	CASH_AUDIT_MODE_DROP,	// cash drop - an amount was put into the cash box
	CASH_AUDIT_MODE_TAKE,	// cash take - an amount was taken from the cash box
	NUM_CASH_AUDIT_MODES
};

typedef void (*coinAuditCB)(int coinType, float coinAmount);

extern int CashBox_Init();

extern int CashBox_Loop();

extern float CashBox_Get(); // get the current cashbox contents
extern float CashBox_GetUnSpent();
extern float CashBox_Take(float amount); // returns the amount taken
extern int CashBox_Put(int coinIn, float amount, int altPayId);

extern void CashBox_Disable(void);
extern void CashBox_Enable(void);

extern void CashBox_ConvertCurrency(float old_play_unit, float new_play_unit);
extern int CashBox_GetLastAltPayId();
extern int CashBox_GetLastTakeFullType();

extern float CashBox_GetUnSpent();
extern float CashBox_GetUnSpentCoinType(int coinIn);
extern float CashBox_GetTotal();
extern float CashBox_GetTotalCoinType(int coinIn);
extern int CashBox_SetCoinAuditFunc(uns32 coinAuditMode, uns32 coinType, coinAuditCB coinAuditFunc);
extern coinAuditCB CashBox_GetCoinAuditFunc(uns32 coinAuditMode, uns32 coinType);

#endif	// AUD_H
