#ifndef CORE_INPUT_ENUMS_H
#define CORE_INPUT_ENUMS_H


// To keep things simple,
// Keys are all just mapped straight to the SDL enum of the same name

typedef enum _core_input_enum
{
	// Keyboard keys
	INP_KEY_UNKNOWN = SDLK_UNKNOWN,
	INP_KEY_FIRST = SDLK_FIRST,
	INP_KEY_BACKSPACE = SDLK_BACKSPACE,
	INP_KEY_TAB = SDLK_TAB,
	INP_KEY_CLEAR = SDLK_CLEAR,
	INP_KEY_RETURN = SDLK_RETURN,
	INP_KEY_PAUSE = SDLK_PAUSE,
	INP_KEY_ESCAPE = SDLK_ESCAPE,
	INP_KEY_SPACE = SDLK_SPACE,
	INP_KEY_EXCLAIM = SDLK_EXCLAIM,
	INP_KEY_QUOTEDBL = SDLK_QUOTEDBL,
	INP_KEY_HASH = SDLK_HASH,
	INP_KEY_DOLLAR = SDLK_DOLLAR,
	INP_KEY_AMPERSAND = SDLK_AMPERSAND,
	INP_KEY_QUOTE = SDLK_QUOTE,
	INP_KEY_LEFTPAREN = SDLK_LEFTPAREN,
	INP_KEY_RIGHTPAREN = SDLK_RIGHTPAREN,
	INP_KEY_ASTERISK = SDLK_ASTERISK,
	INP_KEY_PLUS = SDLK_PLUS,
	INP_KEY_COMMA = SDLK_COMMA,
	INP_KEY_MINUS = SDLK_MINUS,
	INP_KEY_PERIOD = SDLK_PERIOD,
	INP_KEY_SLASH = SDLK_SLASH,
	INP_KEY_0 = SDLK_0,
	INP_KEY_1 = SDLK_1,
	INP_KEY_2 = SDLK_2,
	INP_KEY_3 = SDLK_3,
	INP_KEY_4 = SDLK_4,
	INP_KEY_5 = SDLK_5,
	INP_KEY_6 = SDLK_6,
	INP_KEY_7 = SDLK_7,
	INP_KEY_8 = SDLK_8,
	INP_KEY_9 = SDLK_9,
	INP_KEY_COLON = SDLK_COLON,
	INP_KEY_SEMICOLON = SDLK_SEMICOLON,
	INP_KEY_LESS = SDLK_LESS,
	INP_KEY_EQUALS = SDLK_EQUALS,
	INP_KEY_GREATER = SDLK_GREATER,
	INP_KEY_QUESTION = SDLK_QUESTION,
	INP_KEY_AT = SDLK_AT,
	INP_KEY_LEFTBRACKET = SDLK_LEFTBRACKET,
	INP_KEY_BACKSLASH = SDLK_BACKSLASH,
	INP_KEY_RIGHTBRACKET = SDLK_RIGHTBRACKET,
	INP_KEY_CARET = SDLK_CARET,
	INP_KEY_UNDERSCORE = SDLK_UNDERSCORE,
	INP_KEY_BACKQUOTE = SDLK_BACKQUOTE,
	INP_KEY_a = SDLK_a,
	INP_KEY_b = SDLK_b,
	INP_KEY_c = SDLK_c,
	INP_KEY_d = SDLK_d,
	INP_KEY_e = SDLK_e,
	INP_KEY_f = SDLK_f,
	INP_KEY_g = SDLK_g,
	INP_KEY_h = SDLK_h,
	INP_KEY_i = SDLK_i,
	INP_KEY_j = SDLK_j,
	INP_KEY_k = SDLK_k,
	INP_KEY_l = SDLK_l,
	INP_KEY_m = SDLK_m,
	INP_KEY_n = SDLK_n,
	INP_KEY_o = SDLK_o,
	INP_KEY_p = SDLK_p,
	INP_KEY_q = SDLK_q,
	INP_KEY_r = SDLK_r,
	INP_KEY_s = SDLK_s,
	INP_KEY_t = SDLK_t,
	INP_KEY_u = SDLK_u,
	INP_KEY_v = SDLK_v,
	INP_KEY_w = SDLK_w,
	INP_KEY_x = SDLK_x,
	INP_KEY_y = SDLK_y,
	INP_KEY_z = SDLK_z,
	INP_KEY_DELETE = SDLK_DELETE,
	INP_KEY_WORLD_0 = SDLK_WORLD_0,
	INP_KEY_WORLD_1 = SDLK_WORLD_1,
	INP_KEY_WORLD_2 = SDLK_WORLD_2,
	INP_KEY_WORLD_3 = SDLK_WORLD_3,
	INP_KEY_WORLD_4 = SDLK_WORLD_4,
	INP_KEY_WORLD_5 = SDLK_WORLD_5,
	INP_KEY_WORLD_6 = SDLK_WORLD_6,
	INP_KEY_WORLD_7 = SDLK_WORLD_7,
	INP_KEY_WORLD_8 = SDLK_WORLD_8,
	INP_KEY_WORLD_9 = SDLK_WORLD_9,
	INP_KEY_WORLD_10 = SDLK_WORLD_10,
	INP_KEY_WORLD_11 = SDLK_WORLD_11,
	INP_KEY_WORLD_12 = SDLK_WORLD_12,
	INP_KEY_WORLD_13 = SDLK_WORLD_13,
	INP_KEY_WORLD_14 = SDLK_WORLD_14,
	INP_KEY_WORLD_15 = SDLK_WORLD_15,
	INP_KEY_WORLD_16 = SDLK_WORLD_16,
	INP_KEY_WORLD_17 = SDLK_WORLD_17,
	INP_KEY_WORLD_18 = SDLK_WORLD_18,
	INP_KEY_WORLD_19 = SDLK_WORLD_19,
	INP_KEY_WORLD_20 = SDLK_WORLD_20,
	INP_KEY_WORLD_21 = SDLK_WORLD_21,
	INP_KEY_WORLD_22 = SDLK_WORLD_22,
	INP_KEY_WORLD_23 = SDLK_WORLD_23,
	INP_KEY_WORLD_24 = SDLK_WORLD_24,
	INP_KEY_WORLD_25 = SDLK_WORLD_25,
	INP_KEY_WORLD_26 = SDLK_WORLD_26,
	INP_KEY_WORLD_27 = SDLK_WORLD_27,
	INP_KEY_WORLD_28 = SDLK_WORLD_28,
	INP_KEY_WORLD_29 = SDLK_WORLD_29,
	INP_KEY_WORLD_30 = SDLK_WORLD_30,
	INP_KEY_WORLD_31 = SDLK_WORLD_31,
	INP_KEY_WORLD_32 = SDLK_WORLD_32,
	INP_KEY_WORLD_33 = SDLK_WORLD_33,
	INP_KEY_WORLD_34 = SDLK_WORLD_34,
	INP_KEY_WORLD_35 = SDLK_WORLD_35,
	INP_KEY_WORLD_36 = SDLK_WORLD_36,
	INP_KEY_WORLD_37 = SDLK_WORLD_37,
	INP_KEY_WORLD_38 = SDLK_WORLD_38,
	INP_KEY_WORLD_39 = SDLK_WORLD_39,
	INP_KEY_WORLD_40 = SDLK_WORLD_40,
	INP_KEY_WORLD_41 = SDLK_WORLD_41,
	INP_KEY_WORLD_42 = SDLK_WORLD_42,
	INP_KEY_WORLD_43 = SDLK_WORLD_43,
	INP_KEY_WORLD_44 = SDLK_WORLD_44,
	INP_KEY_WORLD_45 = SDLK_WORLD_45,
	INP_KEY_WORLD_46 = SDLK_WORLD_46,
	INP_KEY_WORLD_47 = SDLK_WORLD_47,
	INP_KEY_WORLD_48 = SDLK_WORLD_48,
	INP_KEY_WORLD_49 = SDLK_WORLD_49,
	INP_KEY_WORLD_50 = SDLK_WORLD_50,
	INP_KEY_WORLD_51 = SDLK_WORLD_51,
	INP_KEY_WORLD_52 = SDLK_WORLD_52,
	INP_KEY_WORLD_53 = SDLK_WORLD_53,
	INP_KEY_WORLD_54 = SDLK_WORLD_54,
	INP_KEY_WORLD_55 = SDLK_WORLD_55,
	INP_KEY_WORLD_56 = SDLK_WORLD_56,
	INP_KEY_WORLD_57 = SDLK_WORLD_57,
	INP_KEY_WORLD_58 = SDLK_WORLD_58,
	INP_KEY_WORLD_59 = SDLK_WORLD_59,
	INP_KEY_WORLD_60 = SDLK_WORLD_60,
	INP_KEY_WORLD_61 = SDLK_WORLD_61,
	INP_KEY_WORLD_62 = SDLK_WORLD_62,
	INP_KEY_WORLD_63 = SDLK_WORLD_63,
	INP_KEY_WORLD_64 = SDLK_WORLD_64,
	INP_KEY_WORLD_65 = SDLK_WORLD_65,
	INP_KEY_WORLD_66 = SDLK_WORLD_66,
	INP_KEY_WORLD_67 = SDLK_WORLD_67,
	INP_KEY_WORLD_68 = SDLK_WORLD_68,
	INP_KEY_WORLD_69 = SDLK_WORLD_69,
	INP_KEY_WORLD_70 = SDLK_WORLD_70,
	INP_KEY_WORLD_71 = SDLK_WORLD_71,
	INP_KEY_WORLD_72 = SDLK_WORLD_72,
	INP_KEY_WORLD_73 = SDLK_WORLD_73,
	INP_KEY_WORLD_74 = SDLK_WORLD_74,
	INP_KEY_WORLD_75 = SDLK_WORLD_75,
	INP_KEY_WORLD_76 = SDLK_WORLD_76,
	INP_KEY_WORLD_77 = SDLK_WORLD_77,
	INP_KEY_WORLD_78 = SDLK_WORLD_78,
	INP_KEY_WORLD_79 = SDLK_WORLD_79,
	INP_KEY_WORLD_80 = SDLK_WORLD_80,
	INP_KEY_WORLD_81 = SDLK_WORLD_81,
	INP_KEY_WORLD_82 = SDLK_WORLD_82,
	INP_KEY_WORLD_83 = SDLK_WORLD_83,
	INP_KEY_WORLD_84 = SDLK_WORLD_84,
	INP_KEY_WORLD_85 = SDLK_WORLD_85,
	INP_KEY_WORLD_86 = SDLK_WORLD_86,
	INP_KEY_WORLD_87 = SDLK_WORLD_87,
	INP_KEY_WORLD_88 = SDLK_WORLD_88,
	INP_KEY_WORLD_89 = SDLK_WORLD_89,
	INP_KEY_WORLD_90 = SDLK_WORLD_90,
	INP_KEY_WORLD_91 = SDLK_WORLD_91,
	INP_KEY_WORLD_92 = SDLK_WORLD_92,
	INP_KEY_WORLD_93 = SDLK_WORLD_93,
	INP_KEY_WORLD_94 = SDLK_WORLD_94,
	INP_KEY_WORLD_95 = SDLK_WORLD_95,
	INP_KEY_KP0 = SDLK_KP0,
	INP_KEY_KP1 = SDLK_KP1,
	INP_KEY_KP2 = SDLK_KP2,
	INP_KEY_KP3 = SDLK_KP3,
	INP_KEY_KP4 = SDLK_KP4,
	INP_KEY_KP5 = SDLK_KP5,
	INP_KEY_KP6 = SDLK_KP6,
	INP_KEY_KP7 = SDLK_KP7,
	INP_KEY_KP8 = SDLK_KP8,
	INP_KEY_KP9 = SDLK_KP9,
	INP_KEY_KP_PERIOD = SDLK_KP_PERIOD,
	INP_KEY_KP_DIVIDE = SDLK_KP_DIVIDE,
	INP_KEY_KP_MULTIPLY = SDLK_KP_MULTIPLY,
	INP_KEY_KP_MINUS = SDLK_KP_MINUS,
	INP_KEY_KP_PLUS = SDLK_KP_PLUS,
	INP_KEY_KP_ENTER = SDLK_KP_ENTER,
	INP_KEY_KP_EQUALS = SDLK_KP_EQUALS,
	INP_KEY_UP = SDLK_UP,
	INP_KEY_DOWN = SDLK_DOWN,
	INP_KEY_RIGHT = SDLK_RIGHT,
	INP_KEY_LEFT = SDLK_LEFT,
	INP_KEY_INSERT = SDLK_INSERT,
	INP_KEY_HOME = SDLK_HOME,
	INP_KEY_END = SDLK_END,
	INP_KEY_PAGEUP = SDLK_PAGEUP,
	INP_KEY_PAGEDOWN = SDLK_PAGEDOWN,
	INP_KEY_F1 = SDLK_F1,
	INP_KEY_F2 = SDLK_F2,
	INP_KEY_F3 = SDLK_F3,
	INP_KEY_F4 = SDLK_F4,
	INP_KEY_F5 = SDLK_F5,
	INP_KEY_F6 = SDLK_F6,
	INP_KEY_F7 = SDLK_F7,
	INP_KEY_F8 = SDLK_F8,
	INP_KEY_F9 = SDLK_F9,
	INP_KEY_F10 = SDLK_F10,
	INP_KEY_F11 = SDLK_F11,
	INP_KEY_F12 = SDLK_F12,
	INP_KEY_F13 = SDLK_F13,
	INP_KEY_F14 = SDLK_F14,
	INP_KEY_F15 = SDLK_F15,
	INP_KEY_NUMLOCK = SDLK_NUMLOCK,
	INP_KEY_CAPSLOCK = SDLK_CAPSLOCK,
	INP_KEY_SCROLLOCK = SDLK_SCROLLOCK,
	INP_KEY_RSHIFT = SDLK_RSHIFT,
	INP_KEY_LSHIFT = SDLK_LSHIFT,
	INP_KEY_RCTRL = SDLK_RCTRL,
	INP_KEY_LCTRL = SDLK_LCTRL,
	INP_KEY_RALT = SDLK_RALT,
	INP_KEY_LALT = SDLK_LALT,
	INP_KEY_RMETA = SDLK_RMETA,
	INP_KEY_LMETA = SDLK_LMETA,
	INP_KEY_LSUPER = SDLK_LSUPER,
	INP_KEY_RSUPER = SDLK_RSUPER,
	INP_KEY_MODE = SDLK_MODE,
	INP_KEY_COMPOSE = SDLK_COMPOSE,
	INP_KEY_HELP = SDLK_HELP,
	INP_KEY_PRINT = SDLK_PRINT,
	INP_KEY_SYSREQ = SDLK_SYSREQ,
	INP_KEY_BREAK = SDLK_BREAK,
	INP_KEY_MENU = SDLK_MENU,
	INP_KEY_POWER = SDLK_POWER,
	INP_KEY_EURO = SDLK_EURO,
	INP_KEY_UNDO = SDLK_UNDO,
	INP_KEY_LAST = SDLK_LAST,
	NUM_INP_KEYS,	// Number of keyboard inputs

	// Mouse inputs
	INP_MOUSE_X = NUM_INP_KEYS,
	INP_MOUSE_Y,
	INP_MOUSE_BUTTON0,
	INP_MOUSE_LEFT_BUTTON = INP_MOUSE_BUTTON0,
	INP_MOUSE_BUTTON1,
	INP_MOUSE_RIGHT_BUTTON = INP_MOUSE_BUTTON1,
	INP_MOUSE_BUTTON2,
	INP_MOUSE_MIDDLE_BUTTON = INP_MOUSE_BUTTON2,
	INP_MOUSE_WHEELUP,
	INP_MOUSE_WHEELDWN,

	INP_GUN0_X,
	INP_GUN0_Y,
	INP_GUN0_TRIGGER0,
	INP_GUN0_TRIGGER1,
	INP_GUN0_TRIGGER2,
	INP_GUN0_TRIGGER3,
	INP_GUN0_TRIGGER4,
	INP_GUN0_TRIGGER5,
	INP_GUN0_TRIGGER6,
	INP_GUN0_TRIGGER7,

	INP_GUN1_X,
	INP_GUN1_Y,
	INP_GUN1_TRIGGER0,
	INP_GUN1_TRIGGER1,
	INP_GUN1_TRIGGER2,
	INP_GUN1_TRIGGER3,
	INP_GUN1_TRIGGER4,
	INP_GUN1_TRIGGER5,
	INP_GUN1_TRIGGER6,
	INP_GUN1_TRIGGER7,

	INP_GUN2_X,
	INP_GUN2_Y,
	INP_GUN2_TRIGGER0,
	INP_GUN2_TRIGGER1,
	INP_GUN2_TRIGGER2,
	INP_GUN2_TRIGGER3,
	INP_GUN2_TRIGGER4,
	INP_GUN2_TRIGGER5,
	INP_GUN2_TRIGGER6,
	INP_GUN2_TRIGGER7,

	INP_GUN3_X,
	INP_GUN3_Y,
	INP_GUN3_TRIGGER0,
	INP_GUN3_TRIGGER1,
	INP_GUN3_TRIGGER2,
	INP_GUN3_TRIGGER3,
	INP_GUN3_TRIGGER4,
	INP_GUN3_TRIGGER5,
	INP_GUN3_TRIGGER6,
	INP_GUN3_TRIGGER7,

	INP_CAB_START0,
	INP_CAB_START1,
	INP_CAB_START2,
	INP_CAB_START3,
	INP_CAB_VOLUP,
	INP_CAB_VOLDWN,
	INP_CAB_SERVICE,
	INP_CAB_DIAG,
	INP_CAB_COIN0,
	INP_CAB_COIN1,
	INP_CAB_COIN2,
	INP_CAB_COIN3,

	INP_MENU_MENU_UP,
	INP_MENU_MENU_DOWN,
	INP_MENU_MENU_SELECT,
	INP_MENU_MENU_CANCEL,
	INP_MENU_HOVER_X_P1,
	INP_MENU_HOVER_Y_P1,
	INP_MENU_HOVER_X_P2,
	INP_MENU_HOVER_Y_P2,
	INP_MENU_ANALOG_SELECT,
	INP_MENU_ANALOG_SELECT_P1,
	INP_MENU_ANALOG_SELECT_P2,
	INP_MENU_ANALOG_CANCEL,

	INP_QUIT,
} core_input_enum;

// these are used to signal when a callback should happen
#define INP_PRESSED			0x01
#define INP_RELEASED		0x02
#define INP_HELD			0x04
#define INP_NOTHELD			0x08
#define INP_POS_POSITIVE    0x10
#define INP_POS_NEGATIVE    0x20

#define INP_ALL_STATES  0xFF



#endif // CORE_INPUT_ENUMS_H

