#ifndef LOCALIZATION_H
#define LOCALIZATION_H
// localization.h
// Play Mechanix - Video Game System
//
// Copyright (c) 1998-2010 Play Mechanix Inc. All Rights Reserved
//


/* ************* */
/* == globals == */
/* ************* */

extern CountryCodes	gCurrentCountry;

/* *********************** */
/* == structs and enums == */
/* *********************** */

enum
{
	VERIFY_SYS_NONE,		// 0
	VERIFY_SYS_AVS_ZIP,		// 1, Address Verification System using ZIP code

	// insert new systems above here
	MAX_VERIFY_SYS
};

typedef struct LocalizationCountData
{
	wchar_t c;
	char font[32];
} LocalizationCountData;


typedef void (*textCallback)(wchar_t*, wchar_t*, int, TextParams*);

/*
typedef enum _languageCode
{
	LANGUAGE_ENGLISH,
	LANGUAGE_JAPANESE,
	LANGUAGE_CHINESE,

	LANG_NUM_LANGUAGES
}LanguageCode;

typedef struct _language
{
	LanguageCode	language;
	char			subdir[32];
	char			translationFolder[32];
}Language;
*/

/* *************** */
/* == FUNCTIONS == */
/* *************** */

int			localizationInit();
int			localizationFinal();
int			localizationReloadTranslations();

int			localizationAddLocale(Locale* locale);
// int         localizationAddLanguage(Language* language);

void		OverrideLocaleWithDevLocale();

int			localizationSetLocale(CountryCodes country);
int			localizationSetLanguage(char* language);

int			localizationGetLocaleID();
char*		localizationGetLocaleName();

int			localizationGetOnlineStatus();
char*		localizationGetLanguage();

char*		localizationGetDBQueryServer();
char*		localizationGetDBQueryIP();
int			localizationGetDBQueryPort();
char*		localizationGetDBQueryCert();

char*		localizationGetFileTransferServer();
char*		localizationGetFileTransferIP();
int			localizationGetFileTransferPort();
char*		localizationGetFileTransferCert();

char*		localizationGetTrain();
int			localizationGetPayCardVerifySys();
char*		localizationGetSubdir();
// char*		localizationGetG5SubdirByLanguage(LanguageCode code);

char*		localizationGetDateFormat();

int			localizationTranslate(const char* token, TextParams* copyOutputHere);
int			localizationGetIdentifiers(char*** identifiers, int max);
int			localizationSetTranslation(TextParams* params);
int			localizationDeleteTranslation(TextParams* params);
int			localizationIsIdentifier(char* identifier);
int			localizationCloneTranslation(const char* identifier, const char* new_identifier);
int			localizationMergeTranslations(const char* format_identifier, const char* string_identifier, const char* new_identifier);

int			localizationSetCallback( const char* identifier, textCallback );
int			localizationSetCallbackByString( const char* identifier, char* textCallback_name);
int			localizationPopulate( TextParams* tp );
void		localizationGetString(const char *identifier, wchar_t *output, int outSize);

void		textCallbackHourMinuteSecond( wchar_t* identifier, wchar_t* output, int outSize, TextParams* tp );
int			localizationDateTime(wchar_t* output, int outSize, time_t *timep);
int			localizationDate(wchar_t* output, int outSize, time_t *timep);

int			localizationInstallTextCallback(char *textCallback_name, textCallback callback);

AddressTabOrder *localizationGetAddressTabOrder();
AddressFormat	*localizationGetAddressFormat();

int			localizationCommify( int num, wchar_t *wbuf, int wbuf_size );
int			localizationOrdinalify( int num, wchar_t *wbuf, int wbuf_size );

void		localizationCount();
int			localizationCount_CompareFunc( const void *a, const void *b );
int			localizationCount_WalkTable( HashNode *hn, void *data );


#endif
