#ifndef MCORE_H
#define MCORE_H
// m.h
// Copyright 1998-2004 Play Mechanix Inc. All Rights Reserved
//
// MTM 01 May 05

#define COUNT_ELEMENTS(array) (sizeof(array) / sizeof(array[0]))

#define	MAX_SND_DIST 150.0	
#define	MAX_SND_VOL	255
#define	MIN_SND_VOL	195


#include "g5.h"


typedef struct {
	crd	trans[3];
	crd	rot[3];
	crd	scale[3];
} OCTab;

typedef struct {
	crd vel[3];
	crd velMult[3];
} VelIndexTab_T;

typedef enum _MStrFlags
{
    MSTR_NO_TRUNCATE = 0x00000001,      //will not truncate words
    MSTR_MUST_FIT = 0x00000002,         //even if the words do not fit on final line, they will be included
}MStrFlags;

typedef struct {
	int oid;
	float radius;
} MOBJ_SEARCHRADIUS_TYPE;

EXTERN_C int mGetThousands(int);
EXTERN_C int mGetHundreds(int);
EXTERN_C int mGetTens(int);
EXTERN_C int mGetOnes(int);
EXTERN_C void mKillAndNull(void *vpObj);
EXTERN_C void *mGetParent(void *o);
EXTERN_C void* mGetDispObjByName(char *nameBuf);
EXTERN_C void *mGetObjTyped(char *nameBuf,int subType);
//EXTERN_C void *mNewStrGrp(char *grpName, char *seqName);
//EXTERN_C void *mNewStrGrpLink(char *grpName, char *seqName, char* linkName);
//EXTERN_C void *mAddStrToGrpName(char *trBuf, float x, float y, int just, char *strName, char *seqName, char *grpName);
//EXTERN_C void *mAddStrToGrpPtr(char *trBuf, float x, float y, int just, char *strName, char *progName, Obj *pGrp);
//EXTERN_C void *mStrFront(char *trBuf, float x, float y, int just, void *vgrpO);
//EXTERN_C void* mStrTop(char *trBuf, float x, float y, int just, void *grpO);
//EXTERN_C void *mStrLink(char *trBuf, float x, float y, int just, void *vgrpO, char* link);
//EXTERN_C int mStrLen(char *trBuf, char *font, float *width, float *height );
//EXTERN_C int mStrFit( char *str, int len, char *font, float width, int target_rows, MStrFlags flags);
//EXTERN_C ObjStr *mAddObjStrToGrpPtr(void* ob, float x, float y, int just, char *strName, char *seqName, Obj *pGrp);
//EXTERN_C ObjStr *mObjStrFront(void* ob, float x, float y, int just, void *vgrpO);
//EXTERN_C ObjStr *mObjStrTop(void* ob, float x, float y, int just, void *grpO);
//EXTERN_C ObjStr *mObjStrLink(void* ob, float x, float y, int just, void *vgrpO, char* link);
//EXTERN_C int mKillStrGroup(const char *groupName);
// EXTERN_C void mCreate(char *buf, void *pOV, void *pObj);
EXTERN_C int mKill(char *nameBuf);
EXTERN_C int mKillByResName(char *nameBuf);
EXTERN_C int mCamShakeProc(void *proc);
EXTERN_C void mFreezeSpline(void *vpobj);
EXTERN_C void mUnFreezeSpline(void *vobj);
EXTERN_C float mGetDistFromCamObj(void *vpObj);
EXTERN_C int mObjAlignToVec(Obj *pObj, crd* v3OrienCur, crd* v3OrienDest);
EXTERN_C void *mObjGetColRes( void *o );
EXTERN_C uns32 mGetOAAFlagsFromPrime(void *vpObj);

EXTERN_C int mCam(char *name, int cam_num);

enum
{
	M_JOINT_SPACE_VM,
	M_BIND_SPACE_VM,
};
EXTERN_C int mObjGetJointIndex(Obj* pObj, char* jointName);
EXTERN_C int mSkelGetJointIndex(void* sk, char* jointName);
EXTERN_C int mSkelGetJointVM(void* sk, int joint_num, int vmtype, float *vm, float *trans, float *rot, float *scale );
EXTERN_C int mObjGetJointVM(void *pObj, int joint_num, int vmtype, float *vm, float *trans, float *rot, float *scale );
EXTERN_C int mObjGetJointWorldPos(void *pObj, char* boneName, crd* pos);
EXTERN_C int mObjGetJointScreenPos(void *pObj, char* boneName, crd* pos);
EXTERN_C int mObjGetJointScreenPosXY(void *pObj, char* boneName, float* x, float* y);
EXTERN_C int mObjGetJointVMByName(void *pObj, char *joint, int vmtype, float *vm, float *trans, float *rot, float *scale );
EXTERN_C int mSkelJointIndexCacheInit();


EXTERN_C int mSwapRes(char *buf, void *vpObj);
EXTERN_C int mSwapShader(char *NewShader,ObjDispRes *pObj);
EXTERN_C int mSwapTex(ObjDispRes *pObj, uns32 tex_num, char *name );
EXTERN_C int mSwapTexGen(ObjDispRes *pObj, uns32 tex_num, uns32 texGen );
EXTERN_C int mEnableBlankTex(ObjDispRes *pObj, uns32 tex_num);
EXTERN_C int mDisableBlankTex(ObjDispRes *pObj, uns32 tex_num);

EXTERN_C void* mGetDispFromSeq(void *vpObjSeq);
EXTERN_C void* mGetOVFromSeq(void *vpObjSeq);
EXTERN_C ObjVel* mGetOVFromDisp(void *vpObj);
#define mGetOVFromObj(o)	mGetOVFromDisp(o)
EXTERN_C void* mGetTexOVFromDisp(void *vpObj);
EXTERN_C void* mGetOECFromPrime(void *vpObj);
EXTERN_C void* mGetOLRFromPrime(void *vpObj, char *name);


EXTERN_C void mCreateNumberStringWithCommas(char* buf, int sizebuf, int number);
EXTERN_C int mCreateNumberSegmentString(char* buf, int sizebuf, int number, int power);

// mObjGetColor takes an object of any obj subtype and will put the color
// components into the memory pointed to by red, green, blue, and alpha.
// Returns 0 if no error is encountered.
//
// Notes:
//   - In the event of a group this is the first valid object.
//   - In the event of a string this is the color of the first character in the string.
//
// Error cases (returns -1):
//   - prime is NULL
//   - An unhandled subtype was passed into prime or a group contains only
//     unhandled subtypes.
//   - A string with zero characters is considered invalid.
EXTERN_C int mObjGetColor(Obj *prime, float *red, float *green, float *blue, float *alpha);

// mObjChangeColor takes an object of any obj subtype and applies operation using
// the color components in red, green, blue, and alpha.
// Returns 0 if no error is encountered.
//
// Notes:
//   - In the event of a group this color is applied to all valid objects in the group.
//   - In the event of a string thie color is applied to all characters.
//   - Sets the blend flag if appropriate
//     (i.e. alpha < 1.0 for all types, except strings are non-blended if alpha is 0.0).
//
// Error cases (returns -1):
//   - Prime is NULL
//   - An unhandled sybtype was passed into prime or a group contains only
//     unhandled subtypes
//   - An unknown operation type is encountered (see enum)
enum
{
	M_COLOR_SET = 0,
	M_COLOR_ADD,
	M_COLOR_SUBTRACT,
	M_COLOR_MULTIPLY,
	M_COLOR_DIVIDE,
};
EXTERN_C int mObjChangeColor(Obj *prime, int operation, float red, float green, float blue, float alpha);

EXTERN_C void* mGetDTabFromPrime(void *vpObj, char* seqName);
EXTERN_C float mRandVel(float min, float max);
EXTERN_C int mPosOrNeg(void);
//EXTERN_C void mSlideText(void *vpObj, float x, float y);
EXTERN_C ObjCam* mGetObjsCam(void *o );
EXTERN_C int mGetObjsCamNum(void *o );
EXTERN_C int mChangeObjsCamNum(void *o, int cam, N2 *link_point, int link_after );
EXTERN_C int mResetCam(int camnum);



EXTERN_C int mKillTyped(char *nameBuf,int subType);
//EXTERN_C void *mStrScale(char *trBuf, float x, float y, float xs, float ys, int just, void *vgrpO);
EXTERN_C int mKillBullet(void *cola);
EXTERN_C void mResMulti(char *name, int num);
EXTERN_C uns32 mGetTexByObjName(char *objName);
EXTERN_C uns32 mGetTexByObj(void *vpObj);
EXTERN_C void mVidStopAndKill(char *buf);

EXTERN_C void mObjCopyTransforms(Obj* src, Obj* dst, int killExisting);
EXTERN_C void mObjCopyOV(ObjVel* src, ObjVel* dst);
EXTERN_C void mObjCopyOAT(ObjAttachment* src, ObjAttachment* dst);

/*
EXTERN_C int mAniToVel(void* vpObj, void* vpOV);
EXTERN_C int mObjSignalSeqByName(void *vo,int msig,void *a, char *name );
EXTERN_C int mParseFCargs( void *fcp, int count, float *args );

// EXTERN_C void mCreatePart(void *vpObj);
EXTERN_C int mGetOARVels( void* vpOAR, float *tvel, float *rvel );
EXTERN_C int mMakeOVFromOAR(void* vpOAR, void* vpOV);
EXTERN_C int mMakeOVFromRTS(void* vpObj, void* vpOV);

EXTERN_C int mObjBanBlend(Obj *pObj, char *aniName, int ramp, int blendTime);
EXTERN_C int mObjChannelBAN(Obj *pObj, void *vSMBP, int channel );
#define mObjBAN(pObj, SMBP) mObjChannelBAN( pObj, SMBP, 0)
EXTERN_C int mObjAddAniChannel(Obj *pObj, int channel, int blend_mode );
EXTERN_C int mObjChannelSetBlend( Obj *prime, int channel, float blend_start, float blend_end, float time );
EXTERN_C int mObjChannelSetBlendMode( Obj *prime, int channel, int blend_mode );
EXTERN_C int mObjChannelDisableAnimExceptOnSubskel( Obj *prime, int channel, char* subskel);
EXTERN_C int mObjChannelStopAnimations( Obj *prime, int channel );

EXTERN_C void mObjCopyOAR(ObjAniRes* src, ObjAniRes* dst);
EXTERN_C int mObjCopyOarChannel(ObjAniRes* src, ObjAniRes* dst, int channel);
EXTERN_C void* mGetOARFromPrime(void *vpObj);
EXTERN_C void* mGetAnimChannelOARFromPrime(void *vpObj, int channel);
EXTERN_C void* mGetJointOARFromPrime(void *vpObj);
EXTERN_C void* mGetSkelOARFromPrime(void *vpObj, int channel, char* jointName );
EXTERN_C int mCheckSkelOARFlags(void *vpObj, uns32 flags, int channel );
// finds and kill all animation res attached to an obj
// returns number of animation res killed
EXTERN_C int mKillObjAniRes(void *vo);
EXTERN_C ObjSeqRes* mAddSeqToDispObj(Obj* pObj,char* seqName);
*/

EXTERN_C int mSetObjSpline(Obj *pObj, char *SplineName );

EXTERN_C int mObjSetAlpha(Obj *pObj, int blend, float a, int relative, int recursive );
EXTERN_C int mObjSetColor(Obj *pObj, float *rgb, int recursive );


EXTERN_C void* mGetSplineOKanFromPrime(void *vpObj );
EXTERN_C void* mGetOTANFromPrime(void *vpObj );

#define mGetSplineFromPrime(vpObj) mGetSplineOKanFromPrime(vpObj)

EXTERN_C void* mGetOATFromPrime(void *vpObj);
EXTERN_C void* mGetOAAFromPrime(void *vpObj);
EXTERN_C void* mGetOACFromPrime(void *vpObj, int channel );

EXTERN_C void* mGetObjRTDTDataFromPrime(void *vpObj, char *name, char *type );
EXTERN_C void* mGetObjRTDTDataDataPtrFromPrime(void *vpObj, char *name, char *type );

EXTERN_C int mCountTyped(char *nameBuf,int subType);
EXTERN_C int mCountResTyped(char *ResName,int subType);
EXTERN_C int mActorCountRes(char *ResName);

EXTERN_C ObjGroup *mObjDispGrpGetPartsGroup( ObjDispRes *o ); 

EXTERN_C void *mObjGetOSR( void *o );

EXTERN_C int mKillObjColRes(void *vo);
EXTERN_C void mTurnOffObjColRes(void *vo);

EXTERN_C int mObjCopyAnis( Obj *os, Obj *od );

#include <math.h>
EXTERN_C float mCalcAngleBtwnPoints( crd x1, crd y1, crd x2, crd y2 );
EXTERN_C int mCreateBits( int count, char *res_name, char *prog_name,
						crd x, crd y, crd z, int plane, 
						float min_dist, float max_dist,
						float min_vel, float max_vel,
						float min_angle, float max_angle,
						float vert_acc, float horz_acc,
						float min_scale, float max_scale,
						float hvel_scale, float vvel_scale,
						float min_depth_vel, float max_depth_vel,
						float min_spin_vel, float max_spin_vel,
						float xrot, float yrot, float zrot,
						int bits );




EXTERN_C int mCreateLightRes(void *resp, char *name, int type, 
								float r, float g, float b,
								float xdir, float ydir, float zdir,
								float xpos, float ypos, float zpos,
								float constant_attenuation, float linear_attenuation, float quadratic_attenuation,
								float spotcone, float spotexponent );

EXTERN_C int mObjDispGrpFindChildParts(Obj *objDispGroup, char *partName, Res *resgrp, Obj *newDispGroup, int inclusive);
EXTERN_C int mObjDispGrpFindParentParts(Obj *objDispGroup, char *partName, char *topNode, Res *resgrp, Obj *newDispGroup);
EXTERN_C Obj *mObjDispGrpSplit(void* objDispGroup, char* partName, int upDown, char* topNode, int inclusive);
EXTERN_C void mObjGetVMFromPart(void* objDispGroup, char* partName,  VMType *dst, float* trans, float* rot, float* scale);
EXTERN_C int mObjJointToParent(Obj *part);
EXTERN_C void mObjCopySkel(Obj* dst, Obj* src);

// DON'T USE THIS FUNCTION, USE mObjDispGrpFindChildParts() INSTEAD!!
EXTERN_C void mObjDispGroupChildrenBuildList(void* o, char *name, List *l);

EXTERN_C void mPhysXDispGroupAddPart(void *o, char *name, int *oid);
EXTERN_C void mPhysXAddGroupAsPieces(void *o, N2* lnk, int joinPieces);
EXTERN_C int mPhysXAddDynamicObj(void *o, VMType *vm);
EXTERN_C int mPhysXJoinPartToParent(Obj* group, Obj* part);
EXTERN_C int mObjSearchRadius(crd *pos, crd radius, List *l);



EXTERN_C ObjVel* mAddVelToDispObjByName(char* name);
EXTERN_C ObjVel* mAddVelToDispObjByPtr(Obj* pObj);

EXTERN_C char *mObjDispResGetAtBuf(ObjDispRes *odr );

EXTERN_C void mObjVelClear(ObjVel *pOV);
EXTERN_C void mKillByOID(unsigned int oid);

EXTERN_C int mObjFindBy2DPos(int x, int y, int *oid);
EXTERN_C int mObjFindNearestBy2DPos(int x, int y, int *oid);

EXTERN_C int mObjAttachFXGroup(Obj *o, char *fxgroup, int skel_attach_mode, char *joint, int joint_num, float *offset, uns32 attach_flags );

EXTERN_C void mObjSetPivotPreserveTransforms(ObjVel* ov, float* pivot);
EXTERN_C int mSetPivotFromXYZRCull(Obj* obj);

EXTERN_C void mObjDelEventActions(Obj *o, char *keep);


EXTERN_C int mRayColProp(ObjColRes *ocr, crd *dir, crd *pos, crd *cpos, crd *vmIn);
EXTERN_C int mRayColSkel( ObjSkelRes *osr, ObjColRes *ocr
				 , crd *dir, crd *pos, ObjVel *ov, crd *cpos, crd *vmIn);

EXTERN_C int mPointCol(ObjColRes *ocr,crd *pos, crd* vmat);
void *mObjGetColRes( void *o );

EXTERN_C void* mFindObjByNameTyped(char *nameBuf, int subType);

EXTERN_C uns32 mGetOIDByActorName(char *name);
EXTERN_C int mMakeOVFromOkan(void* vpOKAN, void* vpOV, int use_scale );

EXTERN_C int mGunColTest2D( ObjDispRes *odr, int gnum, int camnum );



void mGetOVForwardXZ(ObjVel* ov, crd* out_forward);
void mGetOVRightXZ(ObjVel* ov, crd* out_right);
float mGetOVAngleToPosXZ(ObjVel* ov, crd* pos);


float mMoveTo(float current, float dest, float deltaTime);
void mShowODR( ObjDispRes* odr );
void mHideODR( ObjDispRes* odr );
int mIsShownODR( ObjDispRes* odr );
void mShowObj( Obj* o, int recursive );
void mHideObj( Obj* o, int recursive );


// override data in osr so that many different instances can share animation
// from one osr (osrOverride).
void mUseOSROverride(ObjSkelRes* osr, ObjSkelRes* osrOverride);
ObjSkelRes* mGetOSROverride(ObjSkelRes* osr);

void mGetResLODNames( char* in_source_name, char* out_res_name, char* out_res_lod_name );

float mCamTimeUntilFrame(ObjCam* cam, float frame);
float mOkanTimeUntilFrame(ObjKeyAnim* okan, float frame);

void mODRSetCubeMap(ObjDispRes* odr, char* name);

ObjFunc* mObjAddFunc(Obj* obj, char* funcName, void* updateFunc, Func_FreeFunc* freeFunc, size_t dataSize);

void mGetQuadSize( ObjDispRes* odr, float* size );
void mGetQuadSize_Res( Res* res, float* size );

void mGetTfmFromDisp5(Res* res, crd* outPos, crd* outRot, crd* outScl);
void mApplyScaleCentered(ObjDispRes* odr);

// sets sort pri of all ODRs linked as children of o
void mSetODRSortPri(Obj* o, float sort_pri);


#endif // ndef M_H
