


int ReportFailure(const char* file, int line, const char* expr, const char* msg, ...);

#if DEBUG && SYS_PC
#define ASSERT(cond, msg, ...) \
	do \
	{ \
		if (!(cond)) \
		{ \
			if (ReportFailure(__FILE__, __LINE__, #cond, msg, __VA_ARGS__) == 1) \
			{ \
				__debugbreak(); \
			} \
		} \
	} while(0)
#else 
#define ASSERT(cond, msg, ...)\
	do \
	{\
		if(!(cond))\
		{\
			char fileStr[512];\
			char assertStr[256];\
			sprintf(fileStr, "Assert File: %s line: %i", __FILE__, __LINE__);\
			sprintf(assertStr, msg, ##__VA_ARGS__);\
			printf("Assert file %s, line %i:\n", __FILE__, __LINE__);\
			printf(msg, ##__VA_ARGS__);\
			printf("\n");\
			ErrorLog("%s\n", fileStr);\
			ErrorLog("%s\n", assertStr);\
		}\
	} while(0)
#endif