#ifndef SYSTEM_INFO_DIAG_H
#define SYSTEM_INFO_DIAG_H

// system_info_diag.h
// Copyright (c) 2011 Play Mechanix Inc. All Rights Reserved
//
// JAL 01-Mar-2011: System Info-related diag functionality

// Information menu priorities
#define DIAG_PRI_INFO				4

// Information submenu priorities
#define DIAG_PRI_INFO_SUB_1		1
#define DIAG_PRI_INFO_SUB_2		2
#define DIAG_PRI_INFO_SUB_3		3
#define DIAG_PRI_INFO_SUB_4		4
#define DIAG_PRI_INFO_SUB_5		5

typedef struct view_log_info_t {
	int  pageNumber;
	int  pageCount;
	int  numLinesTotal;
	int  numLinesPerPage;
	FILE *logFile;
} view_log_info_t; 

int SystemInfoDiagInit(void);
int SystemInfoDiagSetup(int gameLogMaxLineLength, int numGameLogLinesPerPage);

EXTERN_C menu_type_t MenuType_DiagSystemInformation;
EXTERN_C menu_t DiagMenuInformation;
EXTERN_C menu_t DiagMenuSysInfo;
EXTERN_C menu_type_t MenuType_DiagViewGameLog;
EXTERN_C menu_type_t MenuType_DiagViewErrorLog;
EXTERN_C menu_t DiagMenuViewGameLog;
EXTERN_C menu_t DiagMenuViewErrorLog;


#endif // ndef SYSTEM_INFO_DIAG_H

