#ifndef SYSTEM_TESTS_H
#define SYSTEM_TESTS_H

// system_tests.h
// Copyright (c) 2011 Play Mechanix Inc. All Rights Reserved
//
// JAL 23-Mar-2011:  New - System Tests is a central location to gather and house system tests for display in diag, etc.

// --------------------------------------------------------------------------
// These are identifiers that will be used to lookup items in cpmgui/diag.xml
// The pairings need to be added to SystemTestsSwitchInfoTable in system_tests.c
// To keep things concise, I have made these text identifiers match their Input Enum equivalents
// --------------------------------------------------------------------------
#define INP_GUN0_TRIGGER0_ITEM	"SwitchTestGun0Trigger0"
#define INP_GUN0_TRIGGER1_ITEM	"SwitchTestGun0Trigger1"
#define INP_GUN0_TRIGGER2_ITEM	"SwitchTestGun0Trigger2"
#define INP_GUN0_TRIGGER3_ITEM	"SwitchTestGun0Trigger3"
#define INP_GUN0_TRIGGER4_ITEM	"SwitchTestGun0Trigger4"
#define INP_GUN0_TRIGGER5_ITEM	"SwitchTestGun0Trigger5"
#define INP_GUN0_TRIGGER6_ITEM	"SwitchTestGun0Trigger6"
#define INP_GUN0_TRIGGER7_ITEM	"SwitchTestGun0Trigger7"

#define INP_GUN1_TRIGGER0_ITEM	"SwitchTestGun1Trigger0"
#define INP_GUN1_TRIGGER1_ITEM	"SwitchTestGun1Trigger1"
#define INP_GUN1_TRIGGER2_ITEM	"SwitchTestGun1Trigger2"
#define INP_GUN1_TRIGGER3_ITEM	"SwitchTestGun1Trigger3"
#define INP_GUN1_TRIGGER4_ITEM	"SwitchTestGun1Trigger4"
#define INP_GUN1_TRIGGER5_ITEM	"SwitchTestGun1Trigger5"
#define INP_GUN1_TRIGGER6_ITEM	"SwitchTestGun1Trigger6"
#define INP_GUN1_TRIGGER7_ITEM	"SwitchTestGun1Trigger7"

#define INP_GUN2_TRIGGER0_ITEM	"SwitchTestGun2Trigger0"
#define INP_GUN2_TRIGGER1_ITEM	"SwitchTestGun2Trigger1"
#define INP_GUN2_TRIGGER2_ITEM	"SwitchTestGun2Trigger2"
#define INP_GUN2_TRIGGER3_ITEM	"SwitchTestGun2Trigger3"
#define INP_GUN2_TRIGGER4_ITEM	"SwitchTestGun2Trigger4"
#define INP_GUN2_TRIGGER5_ITEM	"SwitchTestGun2Trigger5"
#define INP_GUN2_TRIGGER6_ITEM	"SwitchTestGun2Trigger6"
#define INP_GUN2_TRIGGER7_ITEM	"SwitchTestGun2Trigger7"

#define INP_GUN3_TRIGGER0_ITEM	"SwitchTestGun3Trigger0"
#define INP_GUN3_TRIGGER1_ITEM	"SwitchTestGun3Trigger1"
#define INP_GUN3_TRIGGER2_ITEM	"SwitchTestGun3Trigger2"
#define INP_GUN3_TRIGGER3_ITEM	"SwitchTestGun3Trigger3"
#define INP_GUN3_TRIGGER4_ITEM	"SwitchTestGun3Trigger4"
#define INP_GUN3_TRIGGER5_ITEM	"SwitchTestGun3Trigger5"
#define INP_GUN3_TRIGGER6_ITEM	"SwitchTestGun3Trigger6"
#define INP_GUN3_TRIGGER7_ITEM	"SwitchTestGun3Trigger7"

#define INP_CAB_START0_ITEM		"SwitchTestCabStart0"
#define INP_CAB_START1_ITEM		"SwitchTestCabStart1"
#define INP_CAB_VOLUP_ITEM		"SwitchTestCabVolUp"
#define INP_CAB_VOLDWN_ITEM		"SwitchTestCabVolDown"
#define INP_CAB_SERVICE_ITEM	"SwitchTestCabService"
#define INP_CAB_DIAG_ITEM		"SwitchTestCabDiag"
#define INP_CAB_COIN0_ITEM		"SwitchTestCabCoin0"
#define INP_CAB_COIN1_ITEM		"SwitchTestCabCoin1"
#define INP_CAB_COIN2_ITEM		"SwitchTestCabCoin2"
#define INP_CAB_COIN3_ITEM		"SwitchTestCabCoin3"

#define INP_EMERGENCY_STOP_ITEM		"SwitchTestEmergencyStop"
#define INP_FLOOR_MAT_LEFT_ITEM		"SwitchTestFloorMatLeft"
#define INP_FLOOR_MAT_RIGHT_ITEM	"SwitchTestFloorMatRight"

#define INP_P1_GUN_X				"SwitchTestP1GunX"
#define INP_P1_GUN_Y				"SwitchTestP1GunY"
#define INP_P2_GUN_X				"SwitchTestP2GunX"
#define INP_P2_GUN_Y				"SwitchTestP2GunY"

typedef struct _SystemTestsSwitchInfoTable_s
{
	core_input_enum  switchEnum;
	char			 *switchItemName;
} SystemTestsSwitchInfoTable_t;

extern SystemTestsSwitchInfoTable_t SystemTestsSwitchInfoTable[];
extern int SystemTestsSwitchInfoTableCount;
extern int gSwitchTested[];

// --------------------------------------------------------------------------
// Public Function declarations
// --------------------------------------------------------------------------
int SystemTestsSwitchTestIsActiveByTestItem(char *testItem);
int SystemTestsSwitchTestIsActiveBySwitchEnum(core_input_enum switchEnum);
char *SystemTestsGetSwitchItemNameBySwitchEnum(core_input_enum switchEnum);
core_input_enum SystemTestsGetSwitchEnumBySwitchItemName(char *SwitchItemName);

int SystemTestsSetup(void);
int SystemTestsInit(void);

#endif // ndef SYSTEM_TESTS_H

