// -------------------------------------------------------------------
// tool2_scene_edit.h
//
// Play Mechanix - Video Game System
// Copyright (c) 2004 Play Mechanix Inc. All Rights Reserved

#ifndef NO_TOOL


#ifndef _TOOL2_SCENE_EDIT_H_
#define _TOOL2_SCENE_EDIT_H_

// -------------------------------------------------------------------

// #include "triggers.h"

// -------------------------------------------------------------------

void t2cb_scene_edit_create(void *ptr, void *ptr2);			// - create the scene edit tool
void t2cb_scene_edit_fbutton_create(void *ptr, void *ptr2);	// - create the auxillary function buttons for the scene edit tool
void t2cb_scene_edit_save(void *ptr, void *ptr2);			// - save the current scene
void t2cb_scene_edit_run(void *ptr, void *ptr2);			// - run the scene
void t2cb_scene_edit_run_cb(SceneType *scene);
void t2cb_scene_edit_update(void *ptr, void *ptr2);			// - sync the data between the gui and the scene data
void t2cb_scene_edit_editprogram(void *ptr, void *ptr2);	// - launch the program edit tool for the scene's program
void t2cb_scene_edit_addresource(void *ptr, void *ptr2);	// - add a resource to the resource list
void t2cb_scene_edit_addsceneresource(void *ptr, void *ptr2);	// - add a scene to the resource list
void t2cb_scene_edit_addactor(void *ptr, void *ptr2);		// - add an actor to the actor list
void t2cb_scene_edit_adddispatcher(void *ptr, void *ptr2);
void t2cb_scene_edit_addtrigger(void *ptr, void *ptr2);
void t2cb_scene_edit_addtrigger_btn(void *ptr, void *ptr2);
void t2cb_scene_edit_addresource_add(void *ptr, void *ptr2);// - when you press the "add" button 
void t2cb_scene_edit_addsceneresource_add(void *ptr, void *ptr2);// - when you press the "add" button 

void t2cb_scene_edit_loadresources(void *ptr, void *ptr2);	// - load all of the resource files

void t2cb_scene_edit_wipe(void);

void t2cb_scene_edit_settings_create(void *ptr, void *ptr2);// - create the gui elements for the "settings" tab
void t2cb_scene_edit_settings_update(void *ptr, void *ptr2);// - update function for the scene settings tab

void t2cb_scene_edit_dispatcherslist_update(void *ptr, void *ptr2);

void t2cb_scene_edit_actorwin_create(void *ptr, void *ptr2);
void t2cb_scene_edit_actorwin_update(SceneActor *actor);
void t2cb_scene_edit_actorwin_createactor(void *ptr, void *ptr2);

void t2cb_scene_edit_actorlist_update(void *ptr, void *ptr2);	// - update function for the actor list tab
void t2cb_scene_edit_actorlist_miniwin_create(void *ptr, void *ptr2);
void t2cb_scene_edit_actorlist_minwin_hidetoggle(void *ptr, void *ptr2);
void t2cb_scene_edit_actorlist_miniwin_delete(void *ptr, void *ptr2);
void t2cb_scene_edit_actorlist_miniwin_moveup(void *ptr, void *ptr2);
void t2cb_scene_edit_actorlist_miniwin_movedown(void *ptr, void *ptr2);
void t2cb_scene_edit_actorlist_miniwin_clone(void *ptr, void *ptr2);
extern int scene_actorlist_callback(Trigger *t, TriggerEvent *te); // from scene_core.c
extern int scene_dispatcherlist_callback(Trigger *t, TriggerEvent *te); // from scene_core.c
void t2cb_scene_edit_actorlist_editprogram(void *ptr, void *ptr2);

void t2cb_scene_edit_dispatcherlist_miniwin_create(void *ptr, void *ptr2);
void t2cb_scene_edit_dispatcherlist_miniwin_moveup(void *ptr, void *ptr2);
void t2cb_scene_edit_dispatcherlist_miniwin_movedown(void *ptr, void *ptr2);
void t2cb_scene_edit_dispatcherlist_miniwin_delete(void *ptr, void *ptr2);

void t2cb_scene_edit_triggerlist_miniwin_create(void *ptr, void *ptr2);
void t2cb_scene_edit_triggerlist_miniwin_moveup(void *ptr, void *ptr2);
void t2cb_scene_edit_triggerlist_miniwin_movedown(void *ptr, void *ptr2);
void t2cb_scene_edit_triggerlist_miniwin_delete(void *ptr, void *ptr2);

void t2cb_scene_edit_actorlist_group_hidetoggle(void *ptr, void *ptr2);
void t2cb_scene_edit_actorlist_group_hidetoggle_unassigned(void *ptr, void *ptr2);

void t2cb_scene_edit_fxgrouplist_update(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_miniwin_create(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_miniwin_movedown(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_miniwin_delete(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_emitter_miniwin_create(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_emitter_miniwin_delete(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_emitter_miniwin_onoff(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_emitter_miniwin_clone(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_emitter_miniwin_setdelay(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_test(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_addemitter_func(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_addemitter(void *ptr, void *ptr2);
void t2cb_scene_edit_fxgrouplist_copy(void *ptr, void *ptr2);
void t2cb_do_copy_fxgroup(void *ptr, void *ptr2);

void t2cb_scene_edit_fxgrouplist_addsfx(void *ptr, void *ptr2);

void t2cb_scene_edit_fxgrouplist_sort(void *ptr, void *ptr2);

void t2cb_scene_edit_resourcelist_miniwin_create(void *ptr, void *ptr2);
void t2cb_scene_edit_resourcelist_miniwin_delete(void *ptr, void *ptr2);
void t2cb_scene_edit_resourcelist_miniwin_move(void *ptr, void *ptr2);
void t2cb_scene_edit_resourcelist_miniwin_reload(void *ptr, void *ptr2);

int tool2_util_scene_edit_actorlist_create(SceneType *scene, T2GUI_BASE_TYPE *bptr);
int tool2_util_scene_edit_resourcelist_create(SceneType *scene, T2GUI_BASE_TYPE *bptr);
int tool2_util_scene_edit_dispatcherslist_create(SceneType *scene, T2GUI_BASE_TYPE *bptr);
int tool2_util_scene_edit_triggerlist_create(SceneType *scene, T2GUI_BASE_TYPE *bptr);
int tool2_util_scene_edit_emitterlist_create(ParticleCollection *pc, T2GUI_BASE_TYPE *bptr);
int tool2_util_scene_edit_fxgrouplist_create(ParticleCollection *pc, T2GUI_BASE_TYPE *bptr);

void t2cb_scene_edit_emitterlist_update(void *ptr, void *ptr2);
void t2cb_scene_edit_emitterlist_miniwin_create(void *ptr, void *ptr2);
void t2cb_scene_edit_emitterlist_miniwin_delete(void *ptr, void *ptr2);
void t2cb_scene_edit_emitterlist_miniwin_movedown(void *ptr, void *ptr2);
void t2cb_scene_edit_emitterlist_miniwin_clone(void *ptr, void *ptr2);
int t2cb_scene_scene_edit_emitterlist_callback(Trigger *t, TriggerEvent *te);
int t2cb_scene_scene_edit_emitterlist_kill_callback(Trigger *t, TriggerEvent *te);

void t2cb_scene_edit_emitter_edit(void *ptr, void *ptr2);

void t2cb_scene_edit_locatetriggers(void *ptr, void *ptr2);

void tool2_util_program_edit(char *progname);

void t2cb_actorgrouplist_create(void *ptr, void *ptr2);
void t2cb_actorgrouplist_btn(void *ptr, void *ptr2);

void tool2_scene_edit_aux_draw(void);


void t2cb_particles_edit_update(void *ptr, void *ptr2);


// -------------------------------------------------------------------

#endif

// EOF


#endif // #ifndef NO_TOOL
