#ifndef UTILITIES_DIAG_H
#define UTILITIES_DIAG_H

// utilities_diag.h
// Copyright  2011 Play Mechanix Inc. All Rights Reserved
//
// JAL 10-Jun-2011: Utilities-related diag functionality

// Utilities menu priority
#define DIAG_PRI_UTILITIES			6

// Utilities submenu priorities
#define DIAG_PRI_UTILITIES_SUB_1	1
#define DIAG_PRI_UTILITIES_SUB_2	2
#define DIAG_PRI_UTILITIES_SUB_3	3
#define DIAG_PRI_UTILITIES_SUB_4	4
#define DIAG_PRI_UTILITIES_SUB_5	5

EXTERN_C int UtilitiesDiagInit(void);

int MenuCreateViewCalibrateMenu(menu_t *menu, menu_instance_t *inst, menu_details_t menuDetails);
void MenuViewCalibrateMenuUpdateCB(menu_t *menu);

void textCallbackCalibratePlayer1Instructions( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );
void textCallbackCalibratePlayer2Instructions( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );

void textCallbackCalibratePlayer1Values( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );
void textCallbackCalibratePlayer2Values( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );

void textCallbackCalibratePlayer3Instructions( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );
void textCallbackCalibratePlayer4Instructions( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );

void textCallbackCalibratePlayer3Values( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );
void textCallbackCalibratePlayer4Values( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );


int MenuCreateExportUSBMenu(menu_t *menu, menu_instance_t *inst, menu_details_t menuDetails);
void MenuExportUSBMenuUpdateCB(menu_t *menu);
void textCallbackExportUSBStatus( wchar_t* input, wchar_t* output, int outSize, TextParams* tp );

int MenuCreateWatchdogTestMenu(menu_t *menu, menu_instance_t *inst, menu_details_t menuDetails);
void WatchdogTestMenuOnFocusCB(menu_t *menu);
void WatchdogTestMenuLeaveFocusCB(menu_t *menu);

EXTERN_C menu_t DiagMenuUtilities;
EXTERN_C menu_t DiagMenuCalibrate;
EXTERN_C menu_t DiagMenuWatchdogTest;
EXTERN_C menu_type_t MenuType_Calibrate;
EXTERN_C menu_t DiagMenuExportUSB;
EXTERN_C menu_type_t MenuType_ExportUSB;
EXTERN_C menu_type_t MenuType_DiagWatchdogTest;
EXTERN_C menu_type_t MenuType_DiagCRCCheck;
EXTERN_C menu_t DiagMenuCRCCheck;

#endif // ndef UTILITIES_DIAG_H

// EOF

