#ifndef VID_H
#define VID_H
#include "g5.h"

// vid.h
// Copyright 2004 Play Mechanix Inc. All Rights Reserved
//
// JFL 29 Aug 04

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// SYS_PC|SYS_BB
#if SYS_PC|SYS_BB



#define M_VIDDISP_DBGDISP_NODISP3B  0x001
#define M_VIDDISP_DBGDISP_NODISP3   0x002
#define M_VIDDISP_DBGDISP_FRUST     0x004
#define M_VIDDISP_DBGDISP_FRUST2    0x008
#define M_VIDDISP_DBGDISP_DONTCULL  0x010
#define M_VIDDISP_DBGDISP_NOCHARACTERS   0x20
#define M_VIDDISP_DBGDISP_TEX2X2    0x040
#define M_VIDDISP_DBGDISP_LOD	    0x080
#define M_VIDDISP_DBGDISP_NOPARTICLES   0x100
#define M_VIDDISP_DBGDISP_DRAWALPHA   0x200
#define M_VIDDISP_DBGDISP_ALLNAMES   0x400
#define M_VIDDISP_DBGDISP_FORCE_FPS   0x800
#define M_VIDDISP_DBGDISP_DRAWFXGNAMES   0x1000
#define M_VIDDISP_DBGDISP_WAYPOINTS   0x2000


#define M_VIDDISP_DBGCOL_PROPCOL    0x01
#define M_VIDDISP_DBGCOL_SKELCOL     0x02
#define M_VIDDISP_DBGCOL_SOLID       0x04

#define M_VIDDISP_DBGCOL_FULL       0x10
#define M_VIDDISP_DBGCOL_GNDBOXES   0x20



#define M_VIDDISP_DBGBENCH_TIMERS				0x01
#define M_VIDDISP_DBGBENCH_DRAWGAMEINFO			0x02
#define M_VIDDISP_DBGBENCH_APIINFO				0x04
#define M_VIDDISP_DBGBENCH_LOGTIMERS			0x08
#define M_VIDDISP_DBGBENCH_BASELINE_TIMERS		0x10
#define M_VIDDISP_DBGBENCH_BASELINE_RESET		0x20
#define M_VIDDISP_DBGBENCH_COUNT_RENDER			0x40
#define M_VIDDISP_DBGBENCH_DRAWMOTIONINFO		0x80
#define M_VIDDISP_DBGBENCH_BUDGET_TIMERS		0x100

// Default angle (in degrees) of the face re-sort threshold angle
#define DEFAULT_GLOBAL_FACE_RESORT_ANGLE 25.0f


// standard def
//#define M_VID_ASPECT_RATIO 4.0f/3.0f
// hd
//#define M_VID_ASPECT_RATIO 16.0f/9.0f
// our funky LCD def
//#define M_VID_ASPECT_RATIO (VidDisp.Cam2D_W / VidDisp.Cam2D_H)

typedef struct
{
	int do_this_frame;
	int camera_num;
	int x;
	int y;
	int width;
	int height;

	uns32 texgen;
	int tex_width;
	int tex_height;

} ScreenGrabData;

typedef struct
{
	uns32	flags;

	uns16	screenW;
	uns16	screenH;
	// desired aspect ration of screen (note may differ from screenW/screenH, as when rendering to an off screen buffer and then stretching to fill screen
	float screenAspectRatio; 

	// width/height of the compiled in Dflt 2D camera, 
	// note that scenes/apps are allowed to setup their own cameras
	// however they like
	float Cam2D_W;
	float Cam2D_H;

//	uns16	centerX;
//	uns16	centerY;


	int		fogMode;
	float	fogDensity;
	float	fogNear;
	float	fogFar;
	float	fogRGBA[4];


	float	fogBlendStartMs;
	float	fogBlendCurrentMs;

	float	fogDensity_old;
	float	fogNear_old;
	float	fogFar_old;
	float	fogRGBA_old[4];

	float	fogDensity_new;
	float	fogNear_new;
	float	fogFar_new;
	float	fogRGBA_new[4];


	float	ClearColor[4]; 


	float   ReflectionMapScale;
	float	ReflectionMapClearColor[4]; 

	float   MainRenderBufferScale;
	float   BloomBufferScale;

/*
	uns8	shadowRGBA[4]; // always used for color
	float	shadowDist; // always used for dist
	float	shadowPos[3]; // only if M_VIDDISP_GSHADOW (else use light 
	int		maxLights;
*/
/*
	float	mipMin;
	float	mipMax;
	float	anisotropic;
	int		maxTexWidthHeight;
*/


	int		texAllocs;
	int		texMem;

	int		vboCount;
	int		vboMem;

	int		fboAllocs;
	int		fboMem;  // memory used by our frame buffer objects and their attached textures, depth buffers, stencil buffers, etc...

	// uniform data block buffer objects
	int     udboCount;
	int     udboMem;


	float	gridSize;
	int		gridDim;

	uns8    dbgcol;
	uns8    dbgshad;
	uns32   dbgdisp;
	uns32   dbgbench;
	uns8	dbgtristrip;
	uns8	dbgphysx;
	uns8	dbg_clip_regions;

/*
	int8	dontFlip;
	uns8	showCursor;
*/

/*
	uns8	bSupportVBO;
	uns8	bSoftwareVSync;		//limited software VSync support available
	uns32	bHardwareVSync;		//hardware is handling VSync
	int		vSyncStart;
	uns32	normalFrames;
	uns32	droppedFrames;
	uns32	vsyncTimeouts;
*/
	uns64	VSyncTimerStart;	//micro second time stamp since last known vsync

	char	dbgbb[4][256];
	uns     dbg2x2;

/*
	uns64	dbgTime0;
	uns64	dbgTime1;
	uns64	dbgTime2;
*/

	char	*apiVendor;
	char	*apiVersion;
	char	*apiRenderer;
	char	*apiExtensions;

/*
	uns32	minTri;				//less than, do not draw
	uns32	minQuad;			//less than, do not draw
	char	findResName[64];	//use to BP on a given display resource
*/

	// debug stuff
	// these guys can be used to selectively 'disable' certain features
	char dbgDisableDynLights; // turns off spec and diff, sets ambient = 1.0
	char dbgDisableVertColors; // turns off vert colors (all vert colors set to white)
	unsigned char blanktex; // a 1x1 white texture in format GL_LUMINANCE, used for 'disabling' a texture
	char dbgDisableTex[8]; // will use blanktex instead
	char dbgDisableAmb; // turns off ambient lighting
	char dbgDisableDiff; // turns off diffuse lighting
	char dbgDisableSpec; // turns off specular lighting
	char dbgUseDbgShiny; // use dbgShiny instead of shiny form obj's material
	float dbgShiny;
	char  dbgDisableShadMaps;
	char  dbgDisablePostFX;
	char dbgUseDbgGlowThreshold; // use dbgGlowThreshold instead of glow threshold form obj's material
	float dbgGlowThreshold;

	char dbgShowCull; // draws culling spheres for objs
	char dbgShowCullName[64]; // the name of a specific object whose cull sphere to draw...

	char dbgDrawLights;
	int dbgDrawPostFXBuffer;


	// Hongwen Button
	char dbgUseParallaxMapHeight;
	float dbgParallaxMapHeight;
	//char dbgUseParallaxMapBias;
	//float dbgParallaxMapBias;

	// Hongwen Cull
	char* dbgCurCullName;			
    char  dbgCullSingle;


	int dbgDisableGunMotion;

	char showfps;

	//float ShadIntensityLG;   // shad intensity for the currently active light group
	//float ShadIntensityGlobal; // shad intensity for global shad light

	//float ShadIntensity;  // current shad intensity
	float ShadSplitLambda;
	float ShadFarClip;

	char	dbgUseBloomSettingsForGlow;
	int		dbgOverrideTexEnable;
	char	dbgOverrideTexObjName[PM_NAME_SIZE];
	int		dbgOverrideTex0;
	int		dbgOverrideTex1;
	int		dbgOverrideTex2;
	int		dbgOverrideTex3;
	int		dbgOverrideTex4;

	int		dbgRenderWireframe;
	int		dbgRenderWireframeFull;

	int dbgForce1BitAlpha;

	int enableRecording;
	char RecordingFile[128];
	int DisableLightGroupLights;

	int ParticleLightGroup;

	char	dbgUseDbgAnisotropy;
	char	dbgDbgAnisotropy;
	// highlight textures that a shader expects but have not been bound
	char	dbgShowMissingTextures;
	char	dbgUseMotionBlur;

	// int   dbgUseParticleMaxZ;
	float dbgParticleMaxZ;

	/*
	// more stuff that doesn't really belong here!!
	// water
	int WaterSeed;
	int WaterIterations;
	float WaterHeight;
	float WaterPersistance;
	int   WaterFreq;
	float WaterContrast;

	float WaveAmps[3];
	float WaveScales[3][3];
	float WaveSpeeds[3][3];
	float WaveRots[3][3];
	float WavePos[3][3];
	*/


	ScreenGrabData ScreenGrab;

	float global_facesort_angle;	// threshold angle for resorting
	float dbgFacesortThreshold;		// cos of threshold angle for resorting (only for debug tool)
	uns8 dbgUseFacesortThreshold;		// flag to use debug facesort angle

	uns8 VSyncAvailable;

	int ScreenType;

} VidDispInfo;

enum {
	SCREENTYPE_NORMAL,
	SCREENTYPE_GGG,
	SCREENTYPE_OVR
};

float VidNumScreens(int ScreenType);


// OpenGL doesn't seem to have these..
// http://www.opengl.org/documentation/specs/version1.2/1.2specs/texture_lod.txt
/*
#define GL_TEXTURE_MIN_LOD 0x813A
#define GL_TEXTURE_MAX_LOD 0x813B
#define GL_TEXTURE_MAX_ANISOTROPY_EXT 0x84FE
#define GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT 0x84FF
*/

enum {
	VIDDRAW_NONE,
	VIDDRAW_JOINT,
	VIDDRAW_AXIS,
	VIDDRAW_GRID,
	VIDDRAW_NUB,
	VIDDRAW_SPHERE,
	VIDDRAW_001,
	VIDDRAW_PROJECTILE,
};


#endif // SYS_PC|SYS_BB
//-----------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////////////
// SYSTEM INDEPENDENT

extern int VidInit(void);
extern void VidFinal(void);
extern int VidReset(uns reset);

#define M_VIDDISP_MINFILTER     0x00000001
#define M_VIDDISP_MAGFILTER     0x00000002
#define M_VIDDISP_WIREFRAME     0x00000004
#define M_VIDDISP_MIPMAP        0x00000008
#define M_VIDDISP_BACKFACE      0x00000010
#define M_VIDDISP_QUALITY       0x00000020
#define M_VIDDISP_BLEND         0x00000040
#define M_VIDDISP_ONEPASSBLEND  0x00000080
#define M_VIDDISP_FOG           0x00000100
#define M_VIDDISP_FOG_C         0x00000200
#define M_VIDDISP_GRID          0x00000400
#define M_VIDDISP_JOINTS        0x00000800
#define M_VIDDISP_NUBS          0x00001000
#define M_VIDDISP_LIGHTS        0x00002000
#define M_VIDDISP_CPFAILURE     0x00004000
#define M_VIDDISP_DONTFLIP      0x00010000
#define M_VIDDISP_SHADOWS       0x00020000
#define M_VIDDISP_PROCHECK      0x00040000 // PRODUCTION
#define M_VIDDISP_PROFAIL       0x00100000 // PRODUCTION
#define M_VIDDISP_GSHADOW       0x00200000 // use VidDisp.shadow (global shadow)
#define M_VIDDISP_GSHADOW_DIR   0x00400000 // directional shadow (else positional)
#define M_VIDDISP_SYNC_VBLANK   0x00800000 // sync to vblank when set
#define M_VIDDISP_SYNC_VBL_SOFT 0x01000000 // try to sync to vblank, but bail if frame time is >= 16ms (60fps), M_VIDDISP_SYNC_VBLANK must also be set
#define M_VIDDISP_ROTATE_RIGHT  0x02000000 // will rotate all cams to the 90 degrees right, use for displaying on vertically mounted monitors...

EXTERN_C VidDispInfo VidDisp;


extern void VidSetDflt2DCamDim( float w, float h );

extern int VidStart(int screen_width, int screen_height, float aspect_ratio, int screen_type );


extern void VidSetRecording(int on, char *filename );

int VidSetFogValues( char *name, float	Density, float	Near, float	Far, float	*RGBA  );
int VidUseFog( char *name );
int VidUseFogBlend( char *name, int blendms);
int VidLoadFog();
int VidSaveFog( char *name );
int VidReloadFog();
void VidFogUpdate(float dt);

void VidSetGfxCardBrightness(float brightness);
void VidSetGfxCardContrast(float contrast);

void VidSetGlobalFaceResortAngle(float angle);


#endif // ndef VID_H
