// game_dongle.h
// Play Mechanix - Video Game System
// Copyright (c) 2010 Play Mechanix Inc. All Rights Reserved
//

#ifndef WIBU_DONGLE_H
#define WIBU_DONGLE_H

#define USE_WIBU_DONGLE 0

#include "g5.h"
#include "CodeMeter.h"
#include <wibuixap.h>


#ifndef SYS_BB
extern int gWibuDongleActive;
#endif


#if USE_WIBU_DONGLE


extern void WibuDongle_Init();
extern int WibuDongle_IsPresent();
extern int WibuDongle_EncryptPrograms();
HCMSysEntry WibuDongle_Get();
void WibuDongle_Release(HCMSysEntry hcmse1);
extern int WibuDongle_Encrypt(HCMSysEntry handle, char *inOutData, unsigned int size);
extern int WibuDongle_Decrypt(HCMSysEntry handle, char *inOutData, unsigned int size);
extern int WibuDongle_Crypt(HCMSysEntry handle, char *inOutData, unsigned int size, CMULONG type);



void WibuDongle_ReadCountryCode(char* code);
void WibuDongle_WriteCountryCode(char* code);

void WibuDongle_ReadCabType(int* cabType);
void WibuDongle_WriteCabType(int cabType);

void WibuDongle_ReadCabSerialNum(int* serialNum);
void WibuDongle_WriteCabSerialNum(int serialNum);

void WibuDongle_ReadFinalized(char* finalized);
void WibuDongle_WriteFinalized(char finalized);

void WibuDongle_ReadLifetimeCoinCount(int* coinCount);
void WibuDongle_WriteLifetimeCoinCount(int coinCount);


#endif

#endif // GAME_DONGLE_H
