// workerbee.h
// Copyright 2010 Play Mechanix Inc. All Rights Reserved
//

#ifndef WORKERBEE_H
#define WORKERBEE_H

#include "g5.h"

enum
{
	WORKERBEE_REQUEST_STATUS_QUEUED,
	WORKERBEE_REQUEST_STATUS_PROCESSING,
	WORKERBEE_REQUEST_STATUS_COMPLETE,
};


typedef struct WorkerBeeRequest
{
	int status;
	uns32 id;
	uns32 dependson_id;
	int thread_id;
	void (*WorkFunc)(void *data);
	void *data;
} WorkerBeeRequest;


int WorkerBee_Init();
uns32 WorkerBee_NewRequest( void (*WorkFunc)(void *data), void *data, uns32 dependson_id );
int WorkerBee_CheckRequestStatus(uns32 id);
int WorkerBee_Finish( int help_out );
int WorkerBee_Loop(int help_out);


#endif
